/*
	Copyright (c) 2004-2006, The Dojo Foundation
	All Rights Reserved.

	Licensed under the Academic Free License version 2.1 or above OR the
	modified BSD license. For more information on Dojo licensing, see:

		http://dojotoolkit.org/community/licensing.shtml
*/

/*
	This is a compiled version of Dojo, built for deployment and not for
	development. To get an editable version, please visit:

		http://dojotoolkit.org

	for documentation and information on getting the source.
*/

if(typeof dojo=="undefined"){
var dj_global=this;
var dj_currentContext=this;
function dj_undef(_1,_2){
return (typeof (_2||dj_currentContext)[_1]=="undefined");
}
if(dj_undef("djConfig",this)){
var djConfig={};
}
if(dj_undef("dojo",this)){
var dojo={};
}
dojo.global=function(){
return dj_currentContext;
};
dojo.locale=djConfig.locale;
dojo.version={major:0,minor:4,patch:2,flag:"p1",revision:Number("$Rev: 7616 $".match(/[0-9]+/)[0]),toString:function(){
with(dojo.version){
return major+"."+minor+"."+patch+flag+" ("+revision+")";
}
}};
dojo.evalProp=function(_3,_4,_5){
if((!_4)||(!_3)){
return undefined;
}
if(!dj_undef(_3,_4)){
return _4[_3];
}
return (_5?(_4[_3]={}):undefined);
};
dojo.parseObjPath=function(_6,_7,_8){
var _9=(_7||dojo.global());
var _a=_6.split(".");
var _b=_a.pop();
for(var i=0,l=_a.length;i<l&&_9;i++){
_9=dojo.evalProp(_a[i],_9,_8);
}
return {obj:_9,prop:_b};
};
dojo.evalObjPath=function(_e,_f){
if(typeof _e!="string"){
return dojo.global();
}
if(_e.indexOf(".")==-1){
return dojo.evalProp(_e,dojo.global(),_f);
}
var ref=dojo.parseObjPath(_e,dojo.global(),_f);
if(ref){
return dojo.evalProp(ref.prop,ref.obj,_f);
}
return null;
};
dojo.errorToString=function(_11){
if(!dj_undef("message",_11)){
return _11.message;
}else{
if(!dj_undef("description",_11)){
return _11.description;
}else{
return _11;
}
}
};
dojo.raise=function(_12,_13){
if(_13){
_12=_12+": "+dojo.errorToString(_13);
}else{
_12=dojo.errorToString(_12);
}
try{
if(djConfig.isDebug){
dojo.hostenv.println("FATAL exception raised: "+_12);
}
}
catch(e){
}
throw _13||Error(_12);
};
dojo.debug=function(){
};
dojo.debugShallow=function(obj){
};
dojo.profile={start:function(){
},end:function(){
},stop:function(){
},dump:function(){
}};
function dj_eval(_15){
return dj_global.eval?dj_global.eval(_15):eval(_15);
}
dojo.unimplemented=function(_16,_17){
var _18="'"+_16+"' not implemented";
if(_17!=null){
_18+=" "+_17;
}
dojo.raise(_18);
};
dojo.deprecated=function(_19,_1a,_1b){
var _1c="DEPRECATED: "+_19;
if(_1a){
_1c+=" "+_1a;
}
if(_1b){
_1c+=" -- will be removed in version: "+_1b;
}
dojo.debug(_1c);
};
dojo.render=(function(){
function vscaffold(_1d,_1e){
var tmp={capable:false,support:{builtin:false,plugin:false},prefixes:_1d};
for(var i=0;i<_1e.length;i++){
tmp[_1e[i]]=false;
}
return tmp;
}
return {name:"",ver:dojo.version,os:{win:false,linux:false,osx:false},html:vscaffold(["html"],["ie","opera","khtml","safari","moz"]),svg:vscaffold(["svg"],["corel","adobe","batik"]),vml:vscaffold(["vml"],["ie"]),swf:vscaffold(["Swf","Flash","Mm"],["mm"]),swt:vscaffold(["Swt"],["ibm"])};
})();
dojo.hostenv=(function(){
var _21={isDebug:false,allowQueryConfig:false,baseScriptUri:"",baseRelativePath:"",libraryScriptUri:"",iePreventClobber:false,ieClobberMinimal:true,preventBackButtonFix:true,delayMozLoadingFix:false,searchIds:[],parseWidgets:true};
if(typeof djConfig=="undefined"){
djConfig=_21;
}else{
for(var _22 in _21){
if(typeof djConfig[_22]=="undefined"){
djConfig[_22]=_21[_22];
}
}
}
return {name_:"(unset)",version_:"(unset)",getName:function(){
return this.name_;
},getVersion:function(){
return this.version_;
},getText:function(uri){
dojo.unimplemented("getText","uri="+uri);
}};
})();
dojo.hostenv.getBaseScriptUri=function(){
if(djConfig.baseScriptUri.length){
return djConfig.baseScriptUri;
}
var uri=new String(djConfig.libraryScriptUri||djConfig.baseRelativePath);
if(!uri){
dojo.raise("Nothing returned by getLibraryScriptUri(): "+uri);
}
var _25=uri.lastIndexOf("/");
djConfig.baseScriptUri=djConfig.baseRelativePath;
return djConfig.baseScriptUri;
};
(function(){
var _26={pkgFileName:"__package__",loading_modules_:{},loaded_modules_:{},addedToLoadingCount:[],removedFromLoadingCount:[],inFlightCount:0,modulePrefixes_:{dojo:{name:"dojo",value:"src"}},setModulePrefix:function(_27,_28){
this.modulePrefixes_[_27]={name:_27,value:_28};
},moduleHasPrefix:function(_29){
var mp=this.modulePrefixes_;
return Boolean(mp[_29]&&mp[_29].value);
},getModulePrefix:function(_2b){
if(this.moduleHasPrefix(_2b)){
return this.modulePrefixes_[_2b].value;
}
return _2b;
},getTextStack:[],loadUriStack:[],loadedUris:[],post_load_:false,modulesLoadedListeners:[],unloadListeners:[],loadNotifying:false};
for(var _2c in _26){
dojo.hostenv[_2c]=_26[_2c];
}
})();
dojo.hostenv.loadPath=function(_2d,_2e,cb){
var uri;
if(_2d.charAt(0)=="/"||_2d.match(/^\w+:/)){
uri=_2d;
}else{
uri=this.getBaseScriptUri()+_2d;
}
if(djConfig.cacheBust&&dojo.render.html.capable){
uri+="?"+String(djConfig.cacheBust).replace(/\W+/g,"");
}
try{
return !_2e?this.loadUri(uri,cb):this.loadUriAndCheck(uri,_2e,cb);
}
catch(e){
dojo.debug(e);
return false;
}
};
dojo.hostenv.loadUri=function(uri,cb){
if(this.loadedUris[uri]){
return true;
}
var _33=this.getText(uri,null,true);
if(!_33){
return false;
}
this.loadedUris[uri]=true;
if(cb){
_33="("+_33+")";
}
var _34=dj_eval(_33);
if(cb){
cb(_34);
}
return true;
};
dojo.hostenv.loadUriAndCheck=function(uri,_36,cb){
var ok=true;
try{
ok=this.loadUri(uri,cb);
}
catch(e){
dojo.debug("failed loading ",uri," with error: ",e);
}
return Boolean(ok&&this.findModule(_36,false));
};
dojo.loaded=function(){
};
dojo.unloaded=function(){
};
dojo.hostenv.loaded=function(){
this.loadNotifying=true;
this.post_load_=true;
var mll=this.modulesLoadedListeners;
for(var x=0;x<mll.length;x++){
mll[x]();
}
this.modulesLoadedListeners=[];
this.loadNotifying=false;
dojo.loaded();
};
dojo.hostenv.unloaded=function(){
var mll=this.unloadListeners;
while(mll.length){
(mll.pop())();
}
dojo.unloaded();
};
dojo.addOnLoad=function(obj,_3d){
var dh=dojo.hostenv;
if(arguments.length==1){
dh.modulesLoadedListeners.push(obj);
}else{
if(arguments.length>1){
dh.modulesLoadedListeners.push(function(){
obj[_3d]();
});
}
}
if(dh.post_load_&&dh.inFlightCount==0&&!dh.loadNotifying){
dh.callLoaded();
}
};
dojo.addOnUnload=function(obj,_40){
var dh=dojo.hostenv;
if(arguments.length==1){
dh.unloadListeners.push(obj);
}else{
if(arguments.length>1){
dh.unloadListeners.push(function(){
obj[_40]();
});
}
}
};
dojo.hostenv.modulesLoaded=function(){
if(this.post_load_){
return;
}
if(this.loadUriStack.length==0&&this.getTextStack.length==0){
if(this.inFlightCount>0){
dojo.debug("files still in flight!");
return;
}
dojo.hostenv.callLoaded();
}
};
dojo.hostenv.callLoaded=function(){
if(typeof setTimeout=="object"||(djConfig["useXDomain"]&&dojo.render.html.opera)){
setTimeout("dojo.hostenv.loaded();",0);
}else{
dojo.hostenv.loaded();
}
};
dojo.hostenv.getModuleSymbols=function(_42){
var _43=_42.split(".");
for(var i=_43.length;i>0;i--){
var _45=_43.slice(0,i).join(".");
if((i==1)&&!this.moduleHasPrefix(_45)){
_43[0]="../"+_43[0];
}else{
var _46=this.getModulePrefix(_45);
if(_46!=_45){
_43.splice(0,i,_46);
break;
}
}
}
return _43;
};
dojo.hostenv._global_omit_module_check=false;
dojo.hostenv.loadModule=function(_47,_48,_49){
if(!_47){
return;
}
_49=this._global_omit_module_check||_49;
var _4a=this.findModule(_47,false);
if(_4a){
return _4a;
}
if(dj_undef(_47,this.loading_modules_)){
this.addedToLoadingCount.push(_47);
}
this.loading_modules_[_47]=1;
var _4b=_47.replace(/\./g,"/")+".js";
var _4c=_47.split(".");
var _4d=this.getModuleSymbols(_47);
var _4e=((_4d[0].charAt(0)!="/")&&!_4d[0].match(/^\w+:/));
var _4f=_4d[_4d.length-1];
var ok;
if(_4f=="*"){
_47=_4c.slice(0,-1).join(".");
while(_4d.length){
_4d.pop();
_4d.push(this.pkgFileName);
_4b=_4d.join("/")+".js";
if(_4e&&_4b.charAt(0)=="/"){
_4b=_4b.slice(1);
}
ok=this.loadPath(_4b,!_49?_47:null);
if(ok){
break;
}
_4d.pop();
}
}else{
_4b=_4d.join("/")+".js";
_47=_4c.join(".");
var _51=!_49?_47:null;
ok=this.loadPath(_4b,_51);
if(!ok&&!_48){
_4d.pop();
while(_4d.length){
_4b=_4d.join("/")+".js";
ok=this.loadPath(_4b,_51);
if(ok){
break;
}
_4d.pop();
_4b=_4d.join("/")+"/"+this.pkgFileName+".js";
if(_4e&&_4b.charAt(0)=="/"){
_4b=_4b.slice(1);
}
ok=this.loadPath(_4b,_51);
if(ok){
break;
}
}
}
if(!ok&&!_49){
dojo.raise("Could not load '"+_47+"'; last tried '"+_4b+"'");
}
}
if(!_49&&!this["isXDomain"]){
_4a=this.findModule(_47,false);
if(!_4a){
dojo.raise("symbol '"+_47+"' is not defined after loading '"+_4b+"'");
}
}
return _4a;
};
dojo.hostenv.startPackage=function(_52){
var _53=String(_52);
var _54=_53;
var _55=_52.split(/\./);
if(_55[_55.length-1]=="*"){
_55.pop();
_54=_55.join(".");
}
var _56=dojo.evalObjPath(_54,true);
this.loaded_modules_[_53]=_56;
this.loaded_modules_[_54]=_56;
return _56;
};
dojo.hostenv.findModule=function(_57,_58){
var lmn=String(_57);
if(this.loaded_modules_[lmn]){
return this.loaded_modules_[lmn];
}
if(_58){
dojo.raise("no loaded module named '"+_57+"'");
}
return null;
};
dojo.kwCompoundRequire=function(_5a){
var _5b=_5a["common"]||[];
var _5c=_5a[dojo.hostenv.name_]?_5b.concat(_5a[dojo.hostenv.name_]||[]):_5b.concat(_5a["default"]||[]);
for(var x=0;x<_5c.length;x++){
var _5e=_5c[x];
if(_5e.constructor==Array){
dojo.hostenv.loadModule.apply(dojo.hostenv,_5e);
}else{
dojo.hostenv.loadModule(_5e);
}
}
};
dojo.require=function(_5f){
dojo.hostenv.loadModule.apply(dojo.hostenv,arguments);
};
dojo.requireIf=function(_60,_61){
var _62=arguments[0];
if((_62===true)||(_62=="common")||(_62&&dojo.render[_62].capable)){
var _63=[];
for(var i=1;i<arguments.length;i++){
_63.push(arguments[i]);
}
dojo.require.apply(dojo,_63);
}
};
dojo.requireAfterIf=dojo.requireIf;
dojo.provide=function(_65){
return dojo.hostenv.startPackage.apply(dojo.hostenv,arguments);
};
dojo.registerModulePath=function(_66,_67){
return dojo.hostenv.setModulePrefix(_66,_67);
};
if(djConfig["modulePaths"]){
for(var param in djConfig["modulePaths"]){
dojo.registerModulePath(param,djConfig["modulePaths"][param]);
}
}
dojo.setModulePrefix=function(_68,_69){
dojo.deprecated("dojo.setModulePrefix(\""+_68+"\", \""+_69+"\")","replaced by dojo.registerModulePath","0.5");
return dojo.registerModulePath(_68,_69);
};
dojo.exists=function(obj,_6b){
var p=_6b.split(".");
for(var i=0;i<p.length;i++){
if(!obj[p[i]]){
return false;
}
obj=obj[p[i]];
}
return true;
};
dojo.hostenv.normalizeLocale=function(_6e){
var _6f=_6e?_6e.toLowerCase():dojo.locale;
if(_6f=="root"){
_6f="ROOT";
}
return _6f;
};
dojo.hostenv.searchLocalePath=function(_70,_71,_72){
_70=dojo.hostenv.normalizeLocale(_70);
var _73=_70.split("-");
var _74=[];
for(var i=_73.length;i>0;i--){
_74.push(_73.slice(0,i).join("-"));
}
_74.push(false);
if(_71){
_74.reverse();
}
for(var j=_74.length-1;j>=0;j--){
var loc=_74[j]||"ROOT";
var _78=_72(loc);
if(_78){
break;
}
}
};
dojo.hostenv.localesGenerated;
dojo.hostenv.registerNlsPrefix=function(){
dojo.registerModulePath("nls","nls");
};
dojo.hostenv.preloadLocalizations=function(){
if(dojo.hostenv.localesGenerated){
dojo.hostenv.registerNlsPrefix();
function preload(_79){
_79=dojo.hostenv.normalizeLocale(_79);
dojo.hostenv.searchLocalePath(_79,true,function(loc){
for(var i=0;i<dojo.hostenv.localesGenerated.length;i++){
if(dojo.hostenv.localesGenerated[i]==loc){
dojo["require"]("nls.dojo_"+loc);
return true;
}
}
return false;
});
}
preload();
var _7c=djConfig.extraLocale||[];
for(var i=0;i<_7c.length;i++){
preload(_7c[i]);
}
}
dojo.hostenv.preloadLocalizations=function(){
};
};
dojo.requireLocalization=function(_7e,_7f,_80,_81){
dojo.hostenv.preloadLocalizations();
var _82=dojo.hostenv.normalizeLocale(_80);
var _83=[_7e,"nls",_7f].join(".");
var _84="";
if(_81){
var _85=_81.split(",");
for(var i=0;i<_85.length;i++){
if(_82.indexOf(_85[i])==0){
if(_85[i].length>_84.length){
_84=_85[i];
}
}
}
if(!_84){
_84="ROOT";
}
}
var _87=_81?_84:_82;
var _88=dojo.hostenv.findModule(_83);
var _89=null;
if(_88){
if(djConfig.localizationComplete&&_88._built){
return;
}
var _8a=_87.replace("-","_");
var _8b=_83+"."+_8a;
_89=dojo.hostenv.findModule(_8b);
}
if(!_89){
_88=dojo.hostenv.startPackage(_83);
var _8c=dojo.hostenv.getModuleSymbols(_7e);
var _8d=_8c.concat("nls").join("/");
var _8e;
dojo.hostenv.searchLocalePath(_87,_81,function(loc){
var _90=loc.replace("-","_");
var _91=_83+"."+_90;
var _92=false;
if(!dojo.hostenv.findModule(_91)){
dojo.hostenv.startPackage(_91);
var _93=[_8d];
if(loc!="ROOT"){
_93.push(loc);
}
_93.push(_7f);
var _94=_93.join("/")+".js";
_92=dojo.hostenv.loadPath(_94,null,function(_95){
var _96=function(){
};
_96.prototype=_8e;
_88[_90]=new _96();
for(var j in _95){
_88[_90][j]=_95[j];
}
});
}else{
_92=true;
}
if(_92&&_88[_90]){
_8e=_88[_90];
}else{
_88[_90]=_8e;
}
if(_81){
return true;
}
});
}
if(_81&&_82!=_84){
_88[_82.replace("-","_")]=_88[_84.replace("-","_")];
}
};
(function(){
var _98=djConfig.extraLocale;
if(_98){
if(!_98 instanceof Array){
_98=[_98];
}
var req=dojo.requireLocalization;
dojo.requireLocalization=function(m,b,_9c,_9d){
req(m,b,_9c,_9d);
if(_9c){
return;
}
for(var i=0;i<_98.length;i++){
req(m,b,_98[i],_9d);
}
};
}
})();
}
if(typeof window!="undefined"){
(function(){
if(djConfig.allowQueryConfig){
var _9f=document.location.toString();
var _a0=_9f.split("?",2);
if(_a0.length>1){
var _a1=_a0[1];
var _a2=_a1.split("&");
for(var x in _a2){
var sp=_a2[x].split("=");
if((sp[0].length>9)&&(sp[0].substr(0,9)=="djConfig.")){
var opt=sp[0].substr(9);
try{
djConfig[opt]=eval(sp[1]);
}
catch(e){
djConfig[opt]=sp[1];
}
}
}
}
}
if(((djConfig["baseScriptUri"]=="")||(djConfig["baseRelativePath"]==""))&&(document&&document.getElementsByTagName)){
var _a6=document.getElementsByTagName("script");
var _a7=/(__package__|dojo|bootstrap1)\.js([\?\.]|$)/i;
for(var i=0;i<_a6.length;i++){
var src=_a6[i].getAttribute("src");
if(!src){
continue;
}
var m=src.match(_a7);
if(m){
var _ab=src.substring(0,m.index);
if(src.indexOf("bootstrap1")>-1){
_ab+="../";
}
if(!this["djConfig"]){
djConfig={};
}
if(djConfig["baseScriptUri"]==""){
djConfig["baseScriptUri"]=_ab;
}
if(djConfig["baseRelativePath"]==""){
djConfig["baseRelativePath"]=_ab;
}
break;
}
}
}
var dr=dojo.render;
var drh=dojo.render.html;
var drs=dojo.render.svg;
var dua=(drh.UA=navigator.userAgent);
var dav=(drh.AV=navigator.appVersion);
var t=true;
var f=false;
drh.capable=t;
drh.support.builtin=t;
dr.ver=parseFloat(drh.AV);
dr.os.mac=dav.indexOf("Macintosh")>=0;
dr.os.win=dav.indexOf("Windows")>=0;
dr.os.linux=dav.indexOf("X11")>=0;
drh.opera=dua.indexOf("Opera")>=0;
drh.khtml=(dav.indexOf("Konqueror")>=0)||(dav.indexOf("Safari")>=0);
drh.safari=dav.indexOf("Safari")>=0;
var _b3=dua.indexOf("Gecko");
drh.mozilla=drh.moz=(_b3>=0)&&(!drh.khtml);
if(drh.mozilla){
drh.geckoVersion=dua.substring(_b3+6,_b3+14);
}
drh.ie=(document.all)&&(!drh.opera);
drh.ie50=drh.ie&&dav.indexOf("MSIE 5.0")>=0;
drh.ie55=drh.ie&&dav.indexOf("MSIE 5.5")>=0;
drh.ie60=drh.ie&&dav.indexOf("MSIE 6.0")>=0;
drh.ie70=drh.ie&&dav.indexOf("MSIE 7.0")>=0;
var cm=document["compatMode"];
drh.quirks=(cm=="BackCompat")||(cm=="QuirksMode")||drh.ie55||drh.ie50;
dojo.locale=dojo.locale||(drh.ie?navigator.userLanguage:navigator.language).toLowerCase();
dr.vml.capable=drh.ie;
drs.capable=f;
drs.support.plugin=f;
drs.support.builtin=f;
var _b5=window["document"];
var tdi=_b5["implementation"];
if((tdi)&&(tdi["hasFeature"])&&(tdi.hasFeature("org.w3c.dom.svg","1.0"))){
drs.capable=t;
drs.support.builtin=t;
drs.support.plugin=f;
}
if(drh.safari){
var tmp=dua.split("AppleWebKit/")[1];
var ver=parseFloat(tmp.split(" ")[0]);
if(ver>=420){
drs.capable=t;
drs.support.builtin=t;
drs.support.plugin=f;
}
}else{
}
})();
dojo.hostenv.startPackage("dojo.hostenv");
dojo.render.name=dojo.hostenv.name_="browser";
dojo.hostenv.searchIds=[];
dojo.hostenv._XMLHTTP_PROGIDS=["Msxml2.XMLHTTP","Microsoft.XMLHTTP","Msxml2.XMLHTTP.4.0"];
dojo.hostenv.getXmlhttpObject=function(){
var _b9=null;
var _ba=null;
try{
_b9=new XMLHttpRequest();
}
catch(e){
}
if(!_b9){
for(var i=0;i<3;++i){
var _bc=dojo.hostenv._XMLHTTP_PROGIDS[i];
try{
_b9=new ActiveXObject(_bc);
}
catch(e){
_ba=e;
}
if(_b9){
dojo.hostenv._XMLHTTP_PROGIDS=[_bc];
break;
}
}
}
if(!_b9){
return dojo.raise("XMLHTTP not available",_ba);
}
return _b9;
};
dojo.hostenv._blockAsync=false;
dojo.hostenv.getText=function(uri,_be,_bf){
if(!_be){
this._blockAsync=true;
}
var _c0=this.getXmlhttpObject();
function isDocumentOk(_c1){
var _c2=_c1["status"];
return Boolean((!_c2)||((200<=_c2)&&(300>_c2))||(_c2==304));
}
if(_be){
var _c3=this,_c4=null,gbl=dojo.global();
var xhr=dojo.evalObjPath("dojo.io.XMLHTTPTransport");
_c0.onreadystatechange=function(){
if(_c4){
gbl.clearTimeout(_c4);
_c4=null;
}
if(_c3._blockAsync||(xhr&&xhr._blockAsync)){
_c4=gbl.setTimeout(function(){
_c0.onreadystatechange.apply(this);
},10);
}else{
if(4==_c0.readyState){
if(isDocumentOk(_c0)){
_be(_c0.responseText);
}
}
}
};
}
_c0.open("GET",uri,_be?true:false);
try{
_c0.send(null);
if(_be){
return null;
}
if(!isDocumentOk(_c0)){
var err=Error("Unable to load "+uri+" status:"+_c0.status);
err.status=_c0.status;
err.responseText=_c0.responseText;
throw err;
}
}
catch(e){
this._blockAsync=false;
if((_bf)&&(!_be)){
return null;
}else{
throw e;
}
}
this._blockAsync=false;
return _c0.responseText;
};
dojo.hostenv.defaultDebugContainerId="dojoDebug";
dojo.hostenv._println_buffer=[];
dojo.hostenv._println_safe=false;
dojo.hostenv.println=function(_c8){
if(!dojo.hostenv._println_safe){
dojo.hostenv._println_buffer.push(_c8);
}else{
try{
var _c9=document.getElementById(djConfig.debugContainerId?djConfig.debugContainerId:dojo.hostenv.defaultDebugContainerId);
if(!_c9){
_c9=dojo.body();
}
var div=document.createElement("div");
div.appendChild(document.createTextNode(_c8));
_c9.appendChild(div);
}
catch(e){
try{
document.write("<div>"+_c8+"</div>");
}
catch(e2){
window.status=_c8;
}
}
}
};
dojo.addOnLoad(function(){
dojo.hostenv._println_safe=true;
while(dojo.hostenv._println_buffer.length>0){
dojo.hostenv.println(dojo.hostenv._println_buffer.shift());
}
});
function dj_addNodeEvtHdlr(_cb,_cc,fp){
var _ce=_cb["on"+_cc]||function(){
};
_cb["on"+_cc]=function(){
fp.apply(_cb,arguments);
_ce.apply(_cb,arguments);
};
return true;
}
function dj_load_init(e){
var _d0=(e&&e.type)?e.type.toLowerCase():"load";
if(arguments.callee.initialized||(_d0!="domcontentloaded"&&_d0!="load")){
return;
}
arguments.callee.initialized=true;
if(typeof (_timer)!="undefined"){
clearInterval(_timer);
delete _timer;
}
var _d1=function(){
if(dojo.render.html.ie){
dojo.hostenv.makeWidgets();
}
};
if(dojo.hostenv.inFlightCount==0){
_d1();
dojo.hostenv.modulesLoaded();
}else{
dojo.hostenv.modulesLoadedListeners.unshift(_d1);
}
}
if(document.addEventListener){
if(dojo.render.html.opera||(dojo.render.html.moz&&(djConfig["enableMozDomContentLoaded"]===true))){
document.addEventListener("DOMContentLoaded",dj_load_init,null);
}
window.addEventListener("load",dj_load_init,null);
}
if(dojo.render.html.ie&&dojo.render.os.win){
document.attachEvent("onreadystatechange",function(e){
if(document.readyState=="complete"){
dj_load_init();
}
});
}
if(/(WebKit|khtml)/i.test(navigator.userAgent)){
var _timer=setInterval(function(){
if(/loaded|complete/.test(document.readyState)){
dj_load_init();
}
},10);
}
if(dojo.render.html.ie){
dj_addNodeEvtHdlr(window,"beforeunload",function(){
dojo.hostenv._unloading=true;
window.setTimeout(function(){
dojo.hostenv._unloading=false;
},0);
});
}
dj_addNodeEvtHdlr(window,"unload",function(){
dojo.hostenv.unloaded();
if((!dojo.render.html.ie)||(dojo.render.html.ie&&dojo.hostenv._unloading)){
dojo.hostenv.unloaded();
}
});
dojo.hostenv.makeWidgets=function(){
var _d3=[];
if(djConfig.searchIds&&djConfig.searchIds.length>0){
_d3=_d3.concat(djConfig.searchIds);
}
if(dojo.hostenv.searchIds&&dojo.hostenv.searchIds.length>0){
_d3=_d3.concat(dojo.hostenv.searchIds);
}
if((djConfig.parseWidgets)||(_d3.length>0)){
if(dojo.evalObjPath("dojo.widget.Parse")){
var _d4=new dojo.xml.Parse();
if(_d3.length>0){
for(var x=0;x<_d3.length;x++){
var _d6=document.getElementById(_d3[x]);
if(!_d6){
continue;
}
var _d7=_d4.parseElement(_d6,null,true);
dojo.widget.getParser().createComponents(_d7);
}
}else{
if(djConfig.parseWidgets){
var _d7=_d4.parseElement(dojo.body(),null,true);
dojo.widget.getParser().createComponents(_d7);
}
}
}
}
};
dojo.addOnLoad(function(){
if(!dojo.render.html.ie){
dojo.hostenv.makeWidgets();
}
});
try{
if(dojo.render.html.ie){
document.namespaces.add("v","urn:schemas-microsoft-com:vml");
document.createStyleSheet().addRule("v\\:*","behavior:url(#default#VML)");
}
}
catch(e){
}
dojo.hostenv.writeIncludes=function(){
};
if(!dj_undef("document",this)){
dj_currentDocument=this.document;
}
dojo.doc=function(){
return dj_currentDocument;
};
dojo.body=function(){
return dojo.doc().body||dojo.doc().getElementsByTagName("body")[0];
};
dojo.byId=function(id,doc){
if((id)&&((typeof id=="string")||(id instanceof String))){
if(!doc){
doc=dj_currentDocument;
}
var ele=doc.getElementById(id);
if(ele&&(ele.id!=id)&&doc.all){
ele=null;
eles=doc.all[id];
if(eles){
if(eles.length){
for(var i=0;i<eles.length;i++){
if(eles[i].id==id){
ele=eles[i];
break;
}
}
}else{
ele=eles;
}
}
}
return ele;
}
return id;
};
dojo.setContext=function(_dc,_dd){
dj_currentContext=_dc;
dj_currentDocument=_dd;
};
dojo._fireCallback=function(_de,_df,_e0){
if((_df)&&((typeof _de=="string")||(_de instanceof String))){
_de=_df[_de];
}
return (_df?_de.apply(_df,_e0||[]):_de());
};
dojo.withGlobal=function(_e1,_e2,_e3,_e4){
var _e5;
var _e6=dj_currentContext;
var _e7=dj_currentDocument;
try{
dojo.setContext(_e1,_e1.document);
_e5=dojo._fireCallback(_e2,_e3,_e4);
}
finally{
dojo.setContext(_e6,_e7);
}
return _e5;
};
dojo.withDoc=function(_e8,_e9,_ea,_eb){
var _ec;
var _ed=dj_currentDocument;
try{
dj_currentDocument=_e8;
_ec=dojo._fireCallback(_e9,_ea,_eb);
}
finally{
dj_currentDocument=_ed;
}
return _ec;
};
}
dojo.requireIf((djConfig["isDebug"]||djConfig["debugAtAllCosts"]),"dojo.debug");
dojo.requireIf(djConfig["debugAtAllCosts"]&&!window.widget&&!djConfig["useXDomain"],"dojo.browser_debug");
dojo.requireIf(djConfig["debugAtAllCosts"]&&!window.widget&&djConfig["useXDomain"],"dojo.browser_debug_xd");
dojo.provide("dojo.lang.common");
dojo.lang.inherits=function(_ee,_ef){
if(!dojo.lang.isFunction(_ef)){
dojo.raise("dojo.inherits: superclass argument ["+_ef+"] must be a function (subclass: ["+_ee+"']");
}
_ee.prototype=new _ef();
_ee.prototype.constructor=_ee;
_ee.superclass=_ef.prototype;
_ee["super"]=_ef.prototype;
};
dojo.lang._mixin=function(obj,_f1){
var _f2={};
for(var x in _f1){
if((typeof _f2[x]=="undefined")||(_f2[x]!=_f1[x])){
obj[x]=_f1[x];
}
}
if(dojo.render.html.ie&&(typeof (_f1["toString"])=="function")&&(_f1["toString"]!=obj["toString"])&&(_f1["toString"]!=_f2["toString"])){
obj.toString=_f1.toString;
}
return obj;
};
dojo.lang.mixin=function(obj,_f5){
for(var i=1,l=arguments.length;i<l;i++){
dojo.lang._mixin(obj,arguments[i]);
}
return obj;
};
dojo.lang.extend=function(_f8,_f9){
for(var i=1,l=arguments.length;i<l;i++){
dojo.lang._mixin(_f8.prototype,arguments[i]);
}
return _f8;
};
dojo.inherits=dojo.lang.inherits;
dojo.mixin=dojo.lang.mixin;
dojo.extend=dojo.lang.extend;
dojo.lang.find=function(_fc,_fd,_fe,_ff){
if(!dojo.lang.isArrayLike(_fc)&&dojo.lang.isArrayLike(_fd)){
dojo.deprecated("dojo.lang.find(value, array)","use dojo.lang.find(array, value) instead","0.5");
var temp=_fc;
_fc=_fd;
_fd=temp;
}
var _101=dojo.lang.isString(_fc);
if(_101){
_fc=_fc.split("");
}
if(_ff){
var step=-1;
var i=_fc.length-1;
var end=-1;
}else{
var step=1;
var i=0;
var end=_fc.length;
}
if(_fe){
while(i!=end){
if(_fc[i]===_fd){
return i;
}
i+=step;
}
}else{
while(i!=end){
if(_fc[i]==_fd){
return i;
}
i+=step;
}
}
return -1;
};
dojo.lang.indexOf=dojo.lang.find;
dojo.lang.findLast=function(_105,_106,_107){
return dojo.lang.find(_105,_106,_107,true);
};
dojo.lang.lastIndexOf=dojo.lang.findLast;
dojo.lang.inArray=function(_108,_109){
return dojo.lang.find(_108,_109)>-1;
};
dojo.lang.isObject=function(it){
if(typeof it=="undefined"){
return false;
}
return (typeof it=="object"||it===null||dojo.lang.isArray(it)||dojo.lang.isFunction(it));
};
dojo.lang.isArray=function(it){
return (it&&it instanceof Array||typeof it=="array");
};
dojo.lang.isArrayLike=function(it){
if((!it)||(dojo.lang.isUndefined(it))){
return false;
}
if(dojo.lang.isString(it)){
return false;
}
if(dojo.lang.isFunction(it)){
return false;
}
if(dojo.lang.isArray(it)){
return true;
}
if((it.tagName)&&(it.tagName.toLowerCase()=="form")){
return false;
}
if(dojo.lang.isNumber(it.length)&&isFinite(it.length)){
return true;
}
return false;
};
dojo.lang.isFunction=function(it){
return (it instanceof Function||typeof it=="function");
};
(function(){
if((dojo.render.html.capable)&&(dojo.render.html["safari"])){
dojo.lang.isFunction=function(it){
if((typeof (it)=="function")&&(it=="[object NodeList]")){
return false;
}
return (it instanceof Function||typeof it=="function");
};
}
})();
dojo.lang.isString=function(it){
return (typeof it=="string"||it instanceof String);
};
dojo.lang.isAlien=function(it){
if(!it){
return false;
}
return !dojo.lang.isFunction(it)&&/\{\s*\[native code\]\s*\}/.test(String(it));
};
dojo.lang.isBoolean=function(it){
return (it instanceof Boolean||typeof it=="boolean");
};
dojo.lang.isNumber=function(it){
return (it instanceof Number||typeof it=="number");
};
dojo.lang.isUndefined=function(it){
return ((typeof (it)=="undefined")&&(it==undefined));
};
dojo.provide("dojo.lang.func");
dojo.lang.hitch=function(_114,_115){
var fcn=(dojo.lang.isString(_115)?_114[_115]:_115)||function(){
};
return function(){
return fcn.apply(_114,arguments);
};
};
dojo.lang.anonCtr=0;
dojo.lang.anon={};
dojo.lang.nameAnonFunc=function(_117,_118,_119){
var nso=(_118||dojo.lang.anon);
if((_119)||((dj_global["djConfig"])&&(djConfig["slowAnonFuncLookups"]==true))){
for(var x in nso){
try{
if(nso[x]===_117){
return x;
}
}
catch(e){
}
}
}
var ret="__"+dojo.lang.anonCtr++;
while(typeof nso[ret]!="undefined"){
ret="__"+dojo.lang.anonCtr++;
}
nso[ret]=_117;
return ret;
};
dojo.lang.forward=function(_11d){
return function(){
return this[_11d].apply(this,arguments);
};
};
dojo.lang.curry=function(_11e,func){
var _120=[];
_11e=_11e||dj_global;
if(dojo.lang.isString(func)){
func=_11e[func];
}
for(var x=2;x<arguments.length;x++){
_120.push(arguments[x]);
}
var _122=(func["__preJoinArity"]||func.length)-_120.length;
function gather(_123,_124,_125){
var _126=_125;
var _127=_124.slice(0);
for(var x=0;x<_123.length;x++){
_127.push(_123[x]);
}
_125=_125-_123.length;
if(_125<=0){
var res=func.apply(_11e,_127);
_125=_126;
return res;
}else{
return function(){
return gather(arguments,_127,_125);
};
}
}
return gather([],_120,_122);
};
dojo.lang.curryArguments=function(_12a,func,args,_12d){
var _12e=[];
var x=_12d||0;
for(x=_12d;x<args.length;x++){
_12e.push(args[x]);
}
return dojo.lang.curry.apply(dojo.lang,[_12a,func].concat(_12e));
};
dojo.lang.tryThese=function(){
for(var x=0;x<arguments.length;x++){
try{
if(typeof arguments[x]=="function"){
var ret=(arguments[x]());
if(ret){
return ret;
}
}
}
catch(e){
dojo.debug(e);
}
}
};
dojo.lang.delayThese=function(farr,cb,_134,_135){
if(!farr.length){
if(typeof _135=="function"){
_135();
}
return;
}
if((typeof _134=="undefined")&&(typeof cb=="number")){
_134=cb;
cb=function(){
};
}else{
if(!cb){
cb=function(){
};
if(!_134){
_134=0;
}
}
}
setTimeout(function(){
(farr.shift())();
cb();
dojo.lang.delayThese(farr,cb,_134,_135);
},_134);
};
dojo.provide("dojo.string.common");
dojo.string.trim=function(str,wh){
if(!str.replace){
return str;
}
if(!str.length){
return str;
}
var re=(wh>0)?(/^\s+/):(wh<0)?(/\s+$/):(/^\s+|\s+$/g);
return str.replace(re,"");
};
dojo.string.trimStart=function(str){
return dojo.string.trim(str,1);
};
dojo.string.trimEnd=function(str){
return dojo.string.trim(str,-1);
};
dojo.string.repeat=function(str,_13c,_13d){
var out="";
for(var i=0;i<_13c;i++){
out+=str;
if(_13d&&i<_13c-1){
out+=_13d;
}
}
return out;
};
dojo.string.pad=function(str,len,c,dir){
var out=String(str);
if(!c){
c="0";
}
if(!dir){
dir=1;
}
while(out.length<len){
if(dir>0){
out=c+out;
}else{
out+=c;
}
}
return out;
};
dojo.string.padLeft=function(str,len,c){
return dojo.string.pad(str,len,c,1);
};
dojo.string.padRight=function(str,len,c){
return dojo.string.pad(str,len,c,-1);
};
dojo.provide("dojo.lang.array");
dojo.lang.mixin(dojo.lang,{has:function(obj,name){
try{
return typeof obj[name]!="undefined";
}
catch(e){
return false;
}
},isEmpty:function(obj){
if(dojo.lang.isObject(obj)){
var tmp={};
var _14f=0;
for(var x in obj){
if(obj[x]&&(!tmp[x])){
_14f++;
break;
}
}
return _14f==0;
}else{
if(dojo.lang.isArrayLike(obj)||dojo.lang.isString(obj)){
return obj.length==0;
}
}
},map:function(arr,obj,_153){
var _154=dojo.lang.isString(arr);
if(_154){
arr=arr.split("");
}
if(dojo.lang.isFunction(obj)&&(!_153)){
_153=obj;
obj=dj_global;
}else{
if(dojo.lang.isFunction(obj)&&_153){
var _155=obj;
obj=_153;
_153=_155;
}
}
if(Array.map){
var _156=Array.map(arr,_153,obj);
}else{
var _156=[];
for(var i=0;i<arr.length;++i){
_156.push(_153.call(obj,arr[i]));
}
}
if(_154){
return _156.join("");
}else{
return _156;
}
},reduce:function(arr,_159,obj,_15b){
var _15c=_159;
if(arguments.length==2){
_15b=_159;
_15c=arr[0];
arr=arr.slice(1);
}else{
if(arguments.length==3){
if(dojo.lang.isFunction(obj)){
_15b=obj;
obj=null;
}
}else{
if(dojo.lang.isFunction(obj)){
var tmp=_15b;
_15b=obj;
obj=tmp;
}
}
}
var ob=obj||dj_global;
dojo.lang.map(arr,function(val){
_15c=_15b.call(ob,_15c,val);
});
return _15c;
},forEach:function(_160,_161,_162){
if(dojo.lang.isString(_160)){
_160=_160.split("");
}
if(Array.forEach){
Array.forEach(_160,_161,_162);
}else{
if(!_162){
_162=dj_global;
}
for(var i=0,l=_160.length;i<l;i++){
_161.call(_162,_160[i],i,_160);
}
}
},_everyOrSome:function(_165,arr,_167,_168){
if(dojo.lang.isString(arr)){
arr=arr.split("");
}
if(Array.every){
return Array[_165?"every":"some"](arr,_167,_168);
}else{
if(!_168){
_168=dj_global;
}
for(var i=0,l=arr.length;i<l;i++){
var _16b=_167.call(_168,arr[i],i,arr);
if(_165&&!_16b){
return false;
}else{
if((!_165)&&(_16b)){
return true;
}
}
}
return Boolean(_165);
}
},every:function(arr,_16d,_16e){
return this._everyOrSome(true,arr,_16d,_16e);
},some:function(arr,_170,_171){
return this._everyOrSome(false,arr,_170,_171);
},filter:function(arr,_173,_174){
var _175=dojo.lang.isString(arr);
if(_175){
arr=arr.split("");
}
var _176;
if(Array.filter){
_176=Array.filter(arr,_173,_174);
}else{
if(!_174){
if(arguments.length>=3){
dojo.raise("thisObject doesn't exist!");
}
_174=dj_global;
}
_176=[];
for(var i=0;i<arr.length;i++){
if(_173.call(_174,arr[i],i,arr)){
_176.push(arr[i]);
}
}
}
if(_175){
return _176.join("");
}else{
return _176;
}
},unnest:function(){
var out=[];
for(var i=0;i<arguments.length;i++){
if(dojo.lang.isArrayLike(arguments[i])){
var add=dojo.lang.unnest.apply(this,arguments[i]);
out=out.concat(add);
}else{
out.push(arguments[i]);
}
}
return out;
},toArray:function(_17b,_17c){
var _17d=[];
for(var i=_17c||0;i<_17b.length;i++){
_17d.push(_17b[i]);
}
return _17d;
}});
dojo.provide("dojo.string.extras");
dojo.string.substituteParams=function(_17f,hash){
var map=(typeof hash=="object")?hash:dojo.lang.toArray(arguments,1);
return _17f.replace(/\%\{(\w+)\}/g,function(_182,key){
if(typeof (map[key])!="undefined"&&map[key]!=null){
return map[key];
}
dojo.raise("Substitution not found: "+key);
});
};
dojo.string.capitalize=function(str){
if(!dojo.lang.isString(str)){
return "";
}
if(arguments.length==0){
str=this;
}
var _185=str.split(" ");
for(var i=0;i<_185.length;i++){
_185[i]=_185[i].charAt(0).toUpperCase()+_185[i].substring(1);
}
return _185.join(" ");
};
dojo.string.isBlank=function(str){
if(!dojo.lang.isString(str)){
return true;
}
return (dojo.string.trim(str).length==0);
};
dojo.string.encodeAscii=function(str){
if(!dojo.lang.isString(str)){
return str;
}
var ret="";
var _18a=escape(str);
var _18b,re=/%u([0-9A-F]{4})/i;
while((_18b=_18a.match(re))){
var num=Number("0x"+_18b[1]);
var _18e=escape("&#"+num+";");
ret+=_18a.substring(0,_18b.index)+_18e;
_18a=_18a.substring(_18b.index+_18b[0].length);
}
ret+=_18a.replace(/\+/g,"%2B");
return ret;
};
dojo.string.escape=function(type,str){
var args=dojo.lang.toArray(arguments,1);
switch(type.toLowerCase()){
case "xml":
case "html":
case "xhtml":
return dojo.string.escapeXml.apply(this,args);
case "sql":
return dojo.string.escapeSql.apply(this,args);
case "regexp":
case "regex":
return dojo.string.escapeRegExp.apply(this,args);
case "javascript":
case "jscript":
case "js":
return dojo.string.escapeJavaScript.apply(this,args);
case "ascii":
return dojo.string.encodeAscii.apply(this,args);
default:
return str;
}
};
dojo.string.escapeXml=function(str,_193){
str=str.replace(/&/gm,"&amp;").replace(/</gm,"&lt;").replace(/>/gm,"&gt;").replace(/"/gm,"&quot;");
if(!_193){
str=str.replace(/'/gm,"&#39;");
}
return str;
};
dojo.string.escapeSql=function(str){
return str.replace(/'/gm,"''");
};
dojo.string.escapeRegExp=function(str){
return str.replace(/\\/gm,"\\\\").replace(/([\f\b\n\t\r[\^$|?*+(){}])/gm,"\\$1");
};
dojo.string.escapeJavaScript=function(str){
return str.replace(/(["'\f\b\n\t\r])/gm,"\\$1");
};
dojo.string.escapeString=function(str){
return ("\""+str.replace(/(["\\])/g,"\\$1")+"\"").replace(/[\f]/g,"\\f").replace(/[\b]/g,"\\b").replace(/[\n]/g,"\\n").replace(/[\t]/g,"\\t").replace(/[\r]/g,"\\r");
};
dojo.string.summary=function(str,len){
if(!len||str.length<=len){
return str;
}
return str.substring(0,len).replace(/\.+$/,"")+"...";
};
dojo.string.endsWith=function(str,end,_19c){
if(_19c){
str=str.toLowerCase();
end=end.toLowerCase();
}
if((str.length-end.length)<0){
return false;
}
return str.lastIndexOf(end)==str.length-end.length;
};
dojo.string.endsWithAny=function(str){
for(var i=1;i<arguments.length;i++){
if(dojo.string.endsWith(str,arguments[i])){
return true;
}
}
return false;
};
dojo.string.startsWith=function(str,_1a0,_1a1){
if(_1a1){
str=str.toLowerCase();
_1a0=_1a0.toLowerCase();
}
return str.indexOf(_1a0)==0;
};
dojo.string.startsWithAny=function(str){
for(var i=1;i<arguments.length;i++){
if(dojo.string.startsWith(str,arguments[i])){
return true;
}
}
return false;
};
dojo.string.has=function(str){
for(var i=1;i<arguments.length;i++){
if(str.indexOf(arguments[i])>-1){
return true;
}
}
return false;
};
dojo.string.normalizeNewlines=function(text,_1a7){
if(_1a7=="\n"){
text=text.replace(/\r\n/g,"\n");
text=text.replace(/\r/g,"\n");
}else{
if(_1a7=="\r"){
text=text.replace(/\r\n/g,"\r");
text=text.replace(/\n/g,"\r");
}else{
text=text.replace(/([^\r])\n/g,"$1\r\n").replace(/\r([^\n])/g,"\r\n$1");
}
}
return text;
};
dojo.string.splitEscaped=function(str,_1a9){
var _1aa=[];
for(var i=0,_1ac=0;i<str.length;i++){
if(str.charAt(i)=="\\"){
i++;
continue;
}
if(str.charAt(i)==_1a9){
_1aa.push(str.substring(_1ac,i));
_1ac=i+1;
}
}
_1aa.push(str.substr(_1ac));
return _1aa;
};
dojo.provide("dojo.AdapterRegistry");
dojo.AdapterRegistry=function(_1ad){
this.pairs=[];
this.returnWrappers=_1ad||false;
};
dojo.lang.extend(dojo.AdapterRegistry,{register:function(name,_1af,wrap,_1b1,_1b2){
var type=(_1b2)?"unshift":"push";
this.pairs[type]([name,_1af,wrap,_1b1]);
},match:function(){
for(var i=0;i<this.pairs.length;i++){
var pair=this.pairs[i];
if(pair[1].apply(this,arguments)){
if((pair[3])||(this.returnWrappers)){
return pair[2];
}else{
return pair[2].apply(this,arguments);
}
}
}
throw new Error("No match found");
},unregister:function(name){
for(var i=0;i<this.pairs.length;i++){
var pair=this.pairs[i];
if(pair[0]==name){
this.pairs.splice(i,1);
return true;
}
}
return false;
}});
dojo.provide("dojo.json");
dojo.json={jsonRegistry:new dojo.AdapterRegistry(),register:function(name,_1ba,wrap,_1bc){
dojo.json.jsonRegistry.register(name,_1ba,wrap,_1bc);
},evalJson:function(json){
try{
return eval("("+json+")");
}
catch(e){
dojo.debug(e);
return json;
}
},serialize:function(o){
var _1bf=typeof (o);
if(_1bf=="undefined"){
return "undefined";
}else{
if((_1bf=="number")||(_1bf=="boolean")){
return o+"";
}else{
if(o===null){
return "null";
}
}
}
if(_1bf=="string"){
return dojo.string.escapeString(o);
}
var me=arguments.callee;
var _1c1;
if(typeof (o.__json__)=="function"){
_1c1=o.__json__();
if(o!==_1c1){
return me(_1c1);
}
}
if(typeof (o.json)=="function"){
_1c1=o.json();
if(o!==_1c1){
return me(_1c1);
}
}
if(_1bf!="function"&&typeof (o.length)=="number"){
var res=[];
for(var i=0;i<o.length;i++){
var val=me(o[i]);
if(typeof (val)!="string"){
val="undefined";
}
res.push(val);
}
return "["+res.join(",")+"]";
}
try{
window.o=o;
_1c1=dojo.json.jsonRegistry.match(o);
return me(_1c1);
}
catch(e){
}
if(_1bf=="function"){
return null;
}
res=[];
for(var k in o){
var _1c6;
if(typeof (k)=="number"){
_1c6="\""+k+"\"";
}else{
if(typeof (k)=="string"){
_1c6=dojo.string.escapeString(k);
}else{
continue;
}
}
val=me(o[k]);
if(typeof (val)!="string"){
continue;
}
res.push(_1c6+":"+val);
}
return "{"+res.join(",")+"}";
}};
dojo.provide("dojo.collections.Store");
dojo.collections.Store=function(_1c7){
var data=[];
var _1c9={};
this.keyField="Id";
this.get=function(){
return data;
};
this.getByKey=function(key){
return _1c9[key];
};
this.getByIndex=function(idx){
return data[idx];
};
this.getIndexOf=function(key){
for(var i=0;i<data.length;i++){
if(data[i].key==key){
return i;
}
}
return -1;
};
this.getData=function(){
var arr=[];
for(var i=0;i<data.length;i++){
arr.push(data[i].src);
}
return arr;
};
this.getDataByKey=function(key){
if(_1c9[key]!=null){
return _1c9[key].src;
}
return null;
};
this.getIndexOfData=function(obj){
for(var i=0;i<data.length;i++){
if(data[i].src==obj){
return i;
}
}
return -1;
};
this.getDataByIndex=function(idx){
if(data[idx]){
return data[idx].src;
}
return null;
};
this.update=function(obj,_1d5,val,_1d7){
var _1d8=_1d5.split("."),i=0,o=obj,_1db;
if(_1d8.length>1){
_1db=_1d8.pop();
do{
if(_1d8[i].indexOf("()")>-1){
var temp=_1d8[i++].split("()")[0];
if(!o[temp]){
dojo.raise("dojo.collections.Store.getField(obj, '"+_1db+"'): '"+temp+"' is not a property of the passed object.");
}else{
o=o[temp]();
}
}else{
o=o[_1d8[i++]];
}
}while(i<_1d8.length&&o!=null);
}else{
_1db=_1d8[0];
}
obj[_1db]=val;
if(!_1d7){
this.onUpdateField(obj,_1d5,val);
}
};
this.forEach=function(fn){
if(Array.forEach){
Array.forEach(data,fn,this);
}else{
for(var i=0;i<data.length;i++){
fn.call(this,data[i]);
}
}
};
this.forEachData=function(fn){
if(Array.forEach){
Array.forEach(this.getData(),fn,this);
}else{
var a=this.getData();
for(var i=0;i<a.length;i++){
fn.call(this,a[i]);
}
}
};
this.setData=function(arr,_1e3){
data=[];
for(var i=0;i<arr.length;i++){
var o={key:arr[i][this.keyField],src:arr[i]};
data.push(o);
_1c9[o.key]=o;
}
if(!_1e3){
this.onSetData();
}
};
this.clearData=function(_1e6){
data=[];
_1c9={};
if(!_1e6){
this.onClearData();
}
};
this.addData=function(obj,key,_1e9){
var k=key||obj[this.keyField];
if(_1c9[k]!=null){
var o=_1c9[k];
o.src=obj;
}else{
var o={key:k,src:obj};
data.push(o);
_1c9[o.key]=o;
}
if(!_1e9){
this.onAddData(o);
}
};
this.addDataRange=function(arr,_1ed){
var _1ee=[];
for(var i=0;i<arr.length;i++){
var k=arr[i][this.keyField];
if(_1c9[k]!=null){
var o=_1c9[k];
o.src=arr[i];
}else{
var o={key:k,src:arr[i]};
data.push(o);
_1c9[k]=o;
}
_1ee.push(o);
}
if(!_1ed){
this.onAddDataRange(_1ee);
}
};
this.addDataByIndex=function(obj,idx,key,_1f5){
var k=key||obj[this.keyField];
if(_1c9[k]!=null){
var i=this.getIndexOf(k);
var o=data.splice(i,1);
o.src=obj;
}else{
var o={key:k,src:obj};
_1c9[k]=o;
}
data.splice(idx,0,o);
if(!_1f5){
this.onAddData(o);
}
};
this.addDataRangeByIndex=function(arr,idx,_1fb){
var _1fc=[];
for(var i=0;i<arr.length;i++){
var k=arr[i][this.keyField];
if(_1c9[k]!=null){
var j=this.getIndexOf(k);
var o=data.splice(j,1);
o.src=arr[i];
}else{
var o={key:k,src:arr[i]};
_1c9[k]=o;
}
_1fc.push(o);
}
data.splice(idx,0,_1fc);
if(!_1fb){
this.onAddDataRange(_1fc);
}
};
this.removeData=function(obj,_202){
var idx=-1;
var o=null;
for(var i=0;i<data.length;i++){
if(data[i].src==obj){
idx=i;
o=data[i];
break;
}
}
if(!_202){
this.onRemoveData(o);
}
if(idx>-1){
data.splice(idx,1);
delete _1c9[o.key];
}
};
this.removeDataRange=function(idx,_207,_208){
var ret=data.splice(idx,_207);
for(var i=0;i<ret.length;i++){
delete _1c9[ret[i].key];
}
if(!_208){
this.onRemoveDataRange(ret);
}
return ret;
};
this.removeDataByKey=function(key,_20c){
this.removeData(this.getDataByKey(key),_20c);
};
this.removeDataByIndex=function(idx,_20e){
this.removeData(this.getDataByIndex(idx),_20e);
};
if(_1c7&&_1c7.length&&_1c7[0]){
this.setData(_1c7,true);
}
};
dojo.extend(dojo.collections.Store,{getField:function(obj,_210){
var _211=_210.split("."),i=0,o=obj;
do{
if(_211[i].indexOf("()")>-1){
var temp=_211[i++].split("()")[0];
if(!o[temp]){
dojo.raise("dojo.collections.Store.getField(obj, '"+_210+"'): '"+temp+"' is not a property of the passed object.");
}else{
o=o[temp]();
}
}else{
o=o[_211[i++]];
}
}while(i<_211.length&&o!=null);
if(i<_211.length){
dojo.raise("dojo.collections.Store.getField(obj, '"+_210+"'): '"+_210+"' is not a property of the passed object.");
}
return o;
},getFromHtml:function(meta,body,_217){
var rows=body.rows;
var ctor=function(row){
var obj={};
for(var i=0;i<meta.length;i++){
var o=obj;
var data=row.cells[i].innerHTML;
var p=meta[i].getField();
if(p.indexOf(".")>-1){
p=p.split(".");
while(p.length>1){
var pr=p.shift();
o[pr]={};
o=o[pr];
}
p=p[0];
}
var type=meta[i].getType();
if(type==String){
o[p]=data;
}else{
if(data){
o[p]=new type(data);
}else{
o[p]=new type();
}
}
}
return obj;
};
var arr=[];
for(var i=0;i<rows.length;i++){
var o=ctor(rows[i]);
if(_217){
_217(o,rows[i]);
}
arr.push(o);
}
return arr;
},onSetData:function(){
},onClearData:function(){
},onAddData:function(obj){
},onAddDataRange:function(arr){
},onRemoveData:function(obj){
},onRemoveDataRange:function(arr){
},onUpdateField:function(obj,_22a,val){
}});
dojo.provide("dojo.gfx.color");
dojo.gfx.color.Color=function(r,g,b,a){
if(dojo.lang.isArray(r)){
this.r=r[0];
this.g=r[1];
this.b=r[2];
this.a=r[3]||1;
}else{
if(dojo.lang.isString(r)){
var rgb=dojo.gfx.color.extractRGB(r);
this.r=rgb[0];
this.g=rgb[1];
this.b=rgb[2];
this.a=g||1;
}else{
if(r instanceof dojo.gfx.color.Color){
this.r=r.r;
this.b=r.b;
this.g=r.g;
this.a=r.a;
}else{
this.r=r;
this.g=g;
this.b=b;
this.a=a;
}
}
}
};
dojo.gfx.color.Color.fromArray=function(arr){
return new dojo.gfx.color.Color(arr[0],arr[1],arr[2],arr[3]);
};
dojo.extend(dojo.gfx.color.Color,{toRgb:function(_232){
if(_232){
return this.toRgba();
}else{
return [this.r,this.g,this.b];
}
},toRgba:function(){
return [this.r,this.g,this.b,this.a];
},toHex:function(){
return dojo.gfx.color.rgb2hex(this.toRgb());
},toCss:function(){
return "rgb("+this.toRgb().join()+")";
},toString:function(){
return this.toHex();
},blend:function(_233,_234){
var rgb=null;
if(dojo.lang.isArray(_233)){
rgb=_233;
}else{
if(_233 instanceof dojo.gfx.color.Color){
rgb=_233.toRgb();
}else{
rgb=new dojo.gfx.color.Color(_233).toRgb();
}
}
return dojo.gfx.color.blend(this.toRgb(),rgb,_234);
}});
dojo.gfx.color.named={white:[255,255,255],black:[0,0,0],red:[255,0,0],green:[0,255,0],lime:[0,255,0],blue:[0,0,255],navy:[0,0,128],gray:[128,128,128],silver:[192,192,192]};
dojo.gfx.color.blend=function(a,b,_238){
if(typeof a=="string"){
return dojo.gfx.color.blendHex(a,b,_238);
}
if(!_238){
_238=0;
}
_238=Math.min(Math.max(-1,_238),1);
_238=((_238+1)/2);
var c=[];
for(var x=0;x<3;x++){
c[x]=parseInt(b[x]+((a[x]-b[x])*_238));
}
return c;
};
dojo.gfx.color.blendHex=function(a,b,_23d){
return dojo.gfx.color.rgb2hex(dojo.gfx.color.blend(dojo.gfx.color.hex2rgb(a),dojo.gfx.color.hex2rgb(b),_23d));
};
dojo.gfx.color.extractRGB=function(_23e){
var hex="0123456789abcdef";
_23e=_23e.toLowerCase();
if(_23e.indexOf("rgb")==0){
var _240=_23e.match(/rgba*\((\d+), *(\d+), *(\d+)/i);
var ret=_240.splice(1,3);
return ret;
}else{
var _242=dojo.gfx.color.hex2rgb(_23e);
if(_242){
return _242;
}else{
return dojo.gfx.color.named[_23e]||[255,255,255];
}
}
};
dojo.gfx.color.hex2rgb=function(hex){
var _244="0123456789ABCDEF";
var rgb=new Array(3);
if(hex.indexOf("#")==0){
hex=hex.substring(1);
}
hex=hex.toUpperCase();
if(hex.replace(new RegExp("["+_244+"]","g"),"")!=""){
return null;
}
if(hex.length==3){
rgb[0]=hex.charAt(0)+hex.charAt(0);
rgb[1]=hex.charAt(1)+hex.charAt(1);
rgb[2]=hex.charAt(2)+hex.charAt(2);
}else{
rgb[0]=hex.substring(0,2);
rgb[1]=hex.substring(2,4);
rgb[2]=hex.substring(4);
}
for(var i=0;i<rgb.length;i++){
rgb[i]=_244.indexOf(rgb[i].charAt(0))*16+_244.indexOf(rgb[i].charAt(1));
}
return rgb;
};
dojo.gfx.color.rgb2hex=function(r,g,b){
if(dojo.lang.isArray(r)){
g=r[1]||0;
b=r[2]||0;
r=r[0]||0;
}
var ret=dojo.lang.map([r,g,b],function(x){
x=new Number(x);
var s=x.toString(16);
while(s.length<2){
s="0"+s;
}
return s;
});
ret.unshift("#");
return ret.join("");
};
dojo.provide("dojo.gfx.color.hsl");
dojo.lang.extend(dojo.gfx.color.Color,{toHsl:function(){
return dojo.gfx.color.rgb2hsl(this.toRgb());
}});
dojo.gfx.color.rgb2hsl=function(r,g,b){
if(dojo.lang.isArray(r)){
b=r[2]||0;
g=r[1]||0;
r=r[0]||0;
}
r/=255;
g/=255;
b/=255;
var h=null;
var s=null;
var l=null;
var min=Math.min(r,g,b);
var max=Math.max(r,g,b);
var _255=max-min;
l=(min+max)/2;
s=0;
if((l>0)&&(l<1)){
s=_255/((l<0.5)?(2*l):(2-2*l));
}
h=0;
if(_255>0){
if((max==r)&&(max!=g)){
h+=(g-b)/_255;
}
if((max==g)&&(max!=b)){
h+=(2+(b-r)/_255);
}
if((max==b)&&(max!=r)){
h+=(4+(r-g)/_255);
}
h*=60;
}
h=(h==0)?360:Math.ceil((h/360)*255);
s=Math.ceil(s*255);
l=Math.ceil(l*255);
return [h,s,l];
};
dojo.gfx.color.hsl2rgb=function(h,s,l){
if(dojo.lang.isArray(h)){
l=h[2]||0;
s=h[1]||0;
h=h[0]||0;
}
h=(h/255)*360;
if(h==360){
h=0;
}
s=s/255;
l=l/255;
while(h<0){
h+=360;
}
while(h>360){
h-=360;
}
var r,g,b;
if(h<120){
r=(120-h)/60;
g=h/60;
b=0;
}else{
if(h<240){
r=0;
g=(240-h)/60;
b=(h-120)/60;
}else{
r=(h-240)/60;
g=0;
b=(360-h)/60;
}
}
r=Math.min(r,1);
g=Math.min(g,1);
b=Math.min(b,1);
r=2*s*r+(1-s);
g=2*s*g+(1-s);
b=2*s*b+(1-s);
if(l<0.5){
r=l*r;
g=l*g;
b=l*b;
}else{
r=(1-l)*r+2*l-1;
g=(1-l)*g+2*l-1;
b=(1-l)*b+2*l-1;
}
r=Math.ceil(r*255);
g=Math.ceil(g*255);
b=Math.ceil(b*255);
return [r,g,b];
};
dojo.gfx.color.hsl2hex=function(h,s,l){
var rgb=dojo.gfx.color.hsl2rgb(h,s,l);
return dojo.gfx.color.rgb2hex(rgb[0],rgb[1],rgb[2]);
};
dojo.gfx.color.hex2hsl=function(hex){
var rgb=dojo.gfx.color.hex2rgb(hex);
return dojo.gfx.color.rgb2hsl(rgb[0],rgb[1],rgb[2]);
};
dojo.provide("dojo.charting.*");
dojo.provide("dojo.dom");
dojo.dom.ELEMENT_NODE=1;
dojo.dom.ATTRIBUTE_NODE=2;
dojo.dom.TEXT_NODE=3;
dojo.dom.CDATA_SECTION_NODE=4;
dojo.dom.ENTITY_REFERENCE_NODE=5;
dojo.dom.ENTITY_NODE=6;
dojo.dom.PROCESSING_INSTRUCTION_NODE=7;
dojo.dom.COMMENT_NODE=8;
dojo.dom.DOCUMENT_NODE=9;
dojo.dom.DOCUMENT_TYPE_NODE=10;
dojo.dom.DOCUMENT_FRAGMENT_NODE=11;
dojo.dom.NOTATION_NODE=12;
dojo.dom.dojoml="http://www.dojotoolkit.org/2004/dojoml";
dojo.dom.xmlns={svg:"http://www.w3.org/2000/svg",smil:"http://www.w3.org/2001/SMIL20/",mml:"http://www.w3.org/1998/Math/MathML",cml:"http://www.xml-cml.org",xlink:"http://www.w3.org/1999/xlink",xhtml:"http://www.w3.org/1999/xhtml",xul:"http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul",xbl:"http://www.mozilla.org/xbl",fo:"http://www.w3.org/1999/XSL/Format",xsl:"http://www.w3.org/1999/XSL/Transform",xslt:"http://www.w3.org/1999/XSL/Transform",xi:"http://www.w3.org/2001/XInclude",xforms:"http://www.w3.org/2002/01/xforms",saxon:"http://icl.com/saxon",xalan:"http://xml.apache.org/xslt",xsd:"http://www.w3.org/2001/XMLSchema",dt:"http://www.w3.org/2001/XMLSchema-datatypes",xsi:"http://www.w3.org/2001/XMLSchema-instance",rdf:"http://www.w3.org/1999/02/22-rdf-syntax-ns#",rdfs:"http://www.w3.org/2000/01/rdf-schema#",dc:"http://purl.org/dc/elements/1.1/",dcq:"http://purl.org/dc/qualifiers/1.0","soap-env":"http://schemas.xmlsoap.org/soap/envelope/",wsdl:"http://schemas.xmlsoap.org/wsdl/",AdobeExtensions:"http://ns.adobe.com/AdobeSVGViewerExtensions/3.0/"};
dojo.dom.isNode=function(wh){
if(typeof Element=="function"){
try{
return wh instanceof Element;
}
catch(e){
}
}else{
return wh&&!isNaN(wh.nodeType);
}
};
dojo.dom.getUniqueId=function(){
var _263=dojo.doc();
do{
var id="dj_unique_"+(++arguments.callee._idIncrement);
}while(_263.getElementById(id));
return id;
};
dojo.dom.getUniqueId._idIncrement=0;
dojo.dom.firstElement=dojo.dom.getFirstChildElement=function(_265,_266){
var node=_265.firstChild;
while(node&&node.nodeType!=dojo.dom.ELEMENT_NODE){
node=node.nextSibling;
}
if(_266&&node&&node.tagName&&node.tagName.toLowerCase()!=_266.toLowerCase()){
node=dojo.dom.nextElement(node,_266);
}
return node;
};
dojo.dom.lastElement=dojo.dom.getLastChildElement=function(_268,_269){
var node=_268.lastChild;
while(node&&node.nodeType!=dojo.dom.ELEMENT_NODE){
node=node.previousSibling;
}
if(_269&&node&&node.tagName&&node.tagName.toLowerCase()!=_269.toLowerCase()){
node=dojo.dom.prevElement(node,_269);
}
return node;
};
dojo.dom.nextElement=dojo.dom.getNextSiblingElement=function(node,_26c){
if(!node){
return null;
}
do{
node=node.nextSibling;
}while(node&&node.nodeType!=dojo.dom.ELEMENT_NODE);
if(node&&_26c&&_26c.toLowerCase()!=node.tagName.toLowerCase()){
return dojo.dom.nextElement(node,_26c);
}
return node;
};
dojo.dom.prevElement=dojo.dom.getPreviousSiblingElement=function(node,_26e){
if(!node){
return null;
}
if(_26e){
_26e=_26e.toLowerCase();
}
do{
node=node.previousSibling;
}while(node&&node.nodeType!=dojo.dom.ELEMENT_NODE);
if(node&&_26e&&_26e.toLowerCase()!=node.tagName.toLowerCase()){
return dojo.dom.prevElement(node,_26e);
}
return node;
};
dojo.dom.moveChildren=function(_26f,_270,trim){
var _272=0;
if(trim){
while(_26f.hasChildNodes()&&_26f.firstChild.nodeType==dojo.dom.TEXT_NODE){
_26f.removeChild(_26f.firstChild);
}
while(_26f.hasChildNodes()&&_26f.lastChild.nodeType==dojo.dom.TEXT_NODE){
_26f.removeChild(_26f.lastChild);
}
}
while(_26f.hasChildNodes()){
_270.appendChild(_26f.firstChild);
_272++;
}
return _272;
};
dojo.dom.copyChildren=function(_273,_274,trim){
var _276=_273.cloneNode(true);
return this.moveChildren(_276,_274,trim);
};
dojo.dom.replaceChildren=function(node,_278){
var _279=[];
if(dojo.render.html.ie){
for(var i=0;i<node.childNodes.length;i++){
_279.push(node.childNodes[i]);
}
}
dojo.dom.removeChildren(node);
node.appendChild(_278);
for(var i=0;i<_279.length;i++){
dojo.dom.destroyNode(_279[i]);
}
};
dojo.dom.removeChildren=function(node){
var _27c=node.childNodes.length;
while(node.hasChildNodes()){
dojo.dom.removeNode(node.firstChild);
}
return _27c;
};
dojo.dom.replaceNode=function(node,_27e){
return node.parentNode.replaceChild(_27e,node);
};
dojo.dom.destroyNode=function(node){
if(node.parentNode){
node=dojo.dom.removeNode(node);
}
if(node.nodeType!=3){
if(dojo.evalObjPath("dojo.event.browser.clean",false)){
dojo.event.browser.clean(node);
}
if(dojo.render.html.ie){
node.outerHTML="";
}
}
};
dojo.dom.removeNode=function(node){
if(node&&node.parentNode){
return node.parentNode.removeChild(node);
}
};
dojo.dom.getAncestors=function(node,_282,_283){
var _284=[];
var _285=(_282&&(_282 instanceof Function||typeof _282=="function"));
while(node){
if(!_285||_282(node)){
_284.push(node);
}
if(_283&&_284.length>0){
return _284[0];
}
node=node.parentNode;
}
if(_283){
return null;
}
return _284;
};
dojo.dom.getAncestorsByTag=function(node,tag,_288){
tag=tag.toLowerCase();
return dojo.dom.getAncestors(node,function(el){
return ((el.tagName)&&(el.tagName.toLowerCase()==tag));
},_288);
};
dojo.dom.getFirstAncestorByTag=function(node,tag){
return dojo.dom.getAncestorsByTag(node,tag,true);
};
dojo.dom.isDescendantOf=function(node,_28d,_28e){
if(_28e&&node){
node=node.parentNode;
}
while(node){
if(node==_28d){
return true;
}
node=node.parentNode;
}
return false;
};
dojo.dom.innerXML=function(node){
if(node.innerXML){
return node.innerXML;
}else{
if(node.xml){
return node.xml;
}else{
if(typeof XMLSerializer!="undefined"){
return (new XMLSerializer()).serializeToString(node);
}
}
}
};
dojo.dom.createDocument=function(){
var doc=null;
var _291=dojo.doc();
if(!dj_undef("ActiveXObject")){
var _292=["MSXML2","Microsoft","MSXML","MSXML3"];
for(var i=0;i<_292.length;i++){
try{
doc=new ActiveXObject(_292[i]+".XMLDOM");
}
catch(e){
}
if(doc){
break;
}
}
}else{
if((_291.implementation)&&(_291.implementation.createDocument)){
doc=_291.implementation.createDocument("","",null);
}
}
return doc;
};
dojo.dom.createDocumentFromText=function(str,_295){
if(!_295){
_295="text/xml";
}
if(!dj_undef("DOMParser")){
var _296=new DOMParser();
return _296.parseFromString(str,_295);
}else{
if(!dj_undef("ActiveXObject")){
var _297=dojo.dom.createDocument();
if(_297){
_297.async=false;
_297.loadXML(str);
return _297;
}else{
dojo.debug("toXml didn't work?");
}
}else{
var _298=dojo.doc();
if(_298.createElement){
var tmp=_298.createElement("xml");
tmp.innerHTML=str;
if(_298.implementation&&_298.implementation.createDocument){
var _29a=_298.implementation.createDocument("foo","",null);
for(var i=0;i<tmp.childNodes.length;i++){
_29a.importNode(tmp.childNodes.item(i),true);
}
return _29a;
}
return ((tmp.document)&&(tmp.document.firstChild?tmp.document.firstChild:tmp));
}
}
}
return null;
};
dojo.dom.prependChild=function(node,_29d){
if(_29d.firstChild){
_29d.insertBefore(node,_29d.firstChild);
}else{
_29d.appendChild(node);
}
return true;
};
dojo.dom.insertBefore=function(node,ref,_2a0){
if((_2a0!=true)&&(node===ref||node.nextSibling===ref)){
return false;
}
var _2a1=ref.parentNode;
_2a1.insertBefore(node,ref);
return true;
};
dojo.dom.insertAfter=function(node,ref,_2a4){
var pn=ref.parentNode;
if(ref==pn.lastChild){
if((_2a4!=true)&&(node===ref)){
return false;
}
pn.appendChild(node);
}else{
return this.insertBefore(node,ref.nextSibling,_2a4);
}
return true;
};
dojo.dom.insertAtPosition=function(node,ref,_2a8){
if((!node)||(!ref)||(!_2a8)){
return false;
}
switch(_2a8.toLowerCase()){
case "before":
return dojo.dom.insertBefore(node,ref);
case "after":
return dojo.dom.insertAfter(node,ref);
case "first":
if(ref.firstChild){
return dojo.dom.insertBefore(node,ref.firstChild);
}else{
ref.appendChild(node);
return true;
}
break;
default:
ref.appendChild(node);
return true;
}
};
dojo.dom.insertAtIndex=function(node,_2aa,_2ab){
var _2ac=_2aa.childNodes;
if(!_2ac.length||_2ac.length==_2ab){
_2aa.appendChild(node);
return true;
}
if(_2ab==0){
return dojo.dom.prependChild(node,_2aa);
}
return dojo.dom.insertAfter(node,_2ac[_2ab-1]);
};
dojo.dom.textContent=function(node,text){
if(arguments.length>1){
var _2af=dojo.doc();
dojo.dom.replaceChildren(node,_2af.createTextNode(text));
return text;
}else{
if(node.textContent!=undefined){
return node.textContent;
}
var _2b0="";
if(node==null){
return _2b0;
}
for(var i=0;i<node.childNodes.length;i++){
switch(node.childNodes[i].nodeType){
case 1:
case 5:
_2b0+=dojo.dom.textContent(node.childNodes[i]);
break;
case 3:
case 2:
case 4:
_2b0+=node.childNodes[i].nodeValue;
break;
default:
break;
}
}
return _2b0;
}
};
dojo.dom.hasParent=function(node){
return Boolean(node&&node.parentNode&&dojo.dom.isNode(node.parentNode));
};
dojo.dom.isTag=function(node){
if(node&&node.tagName){
for(var i=1;i<arguments.length;i++){
if(node.tagName==String(arguments[i])){
return String(arguments[i]);
}
}
}
return "";
};
dojo.dom.setAttributeNS=function(elem,_2b6,_2b7,_2b8){
if(elem==null||((elem==undefined)&&(typeof elem=="undefined"))){
dojo.raise("No element given to dojo.dom.setAttributeNS");
}
if(!((elem.setAttributeNS==undefined)&&(typeof elem.setAttributeNS=="undefined"))){
elem.setAttributeNS(_2b6,_2b7,_2b8);
}else{
var _2b9=elem.ownerDocument;
var _2ba=_2b9.createNode(2,_2b7,_2b6);
_2ba.nodeValue=_2b8;
elem.setAttributeNode(_2ba);
}
};
dojo.provide("dojo.svg");
dojo.mixin(dojo.svg,dojo.dom);
dojo.svg.graphics=dojo.svg.g=new function(d){
this.suspend=function(){
try{
d.documentElement.suspendRedraw(0);
}
catch(e){
}
};
this.resume=function(){
try{
d.documentElement.unsuspendRedraw(0);
}
catch(e){
}
};
this.force=function(){
try{
d.documentElement.forceRedraw();
}
catch(e){
}
};
}(document);
dojo.svg.animations=dojo.svg.anim=new function(d){
this.arePaused=function(){
try{
return d.documentElement.animationsPaused();
}
catch(e){
return false;
}
};
this.pause=function(){
try{
d.documentElement.pauseAnimations();
}
catch(e){
}
};
this.resume=function(){
try{
d.documentElement.unpauseAnimations();
}
catch(e){
}
};
}(document);
dojo.svg.toCamelCase=function(_2bd){
var arr=_2bd.split("-"),cc=arr[0];
for(var i=1;i<arr.length;i++){
cc+=arr[i].charAt(0).toUpperCase()+arr[i].substring(1);
}
return cc;
};
dojo.svg.toSelectorCase=function(_2c1){
return _2c1.replace(/([A-Z])/g,"-$1").toLowerCase();
};
dojo.svg.getStyle=function(node,_2c3){
return document.defaultView.getComputedStyle(node,_2c3);
};
dojo.svg.getNumericStyle=function(node,_2c5){
return parseFloat(dojo.svg.getStyle(node,_2c5));
};
dojo.svg.getOpacity=function(node){
return Math.min(1,dojo.svg.getNumericStyle(node,"fill-opacity"));
};
dojo.svg.setOpacity=function(node,_2c8){
node.setAttributeNS(this.xmlns.svg,"fill-opacity",_2c8);
node.setAttributeNS(this.xmlns.svg,"stroke-opacity",_2c8);
};
dojo.svg.clearOpacity=function(node){
node.setAttributeNS(this.xmlns.svg,"fill-opacity","1.0");
node.setAttributeNS(this.xmlns.svg,"stroke-opacity","1.0");
};
dojo.svg.getCoords=function(node){
if(node.getBBox){
var box=node.getBBox();
return {x:box.x,y:box.y};
}
return null;
};
dojo.svg.setCoords=function(node,_2cd){
var p=dojo.svg.getCoords();
if(!p){
return;
}
var dx=p.x-_2cd.x;
var dy=p.y-_2cd.y;
dojo.svg.translate(node,dx,dy);
};
dojo.svg.getDimensions=function(node){
if(node.getBBox){
var box=node.getBBox();
return {width:box.width,height:box.height};
}
return null;
};
dojo.svg.setDimensions=function(node,dim){
if(node.width){
node.width.baseVal.value=dim.width;
node.height.baseVal.value=dim.height;
}else{
if(node.r){
node.r.baseVal.value=Math.min(dim.width,dim.height)/2;
}else{
if(node.rx){
node.rx.baseVal.value=dim.width/2;
node.ry.baseVal.value=dim.height/2;
}
}
}
};
dojo.svg.translate=function(node,dx,dy){
if(node.transform&&node.ownerSVGElement&&node.ownerSVGElement.createSVGTransform){
var t=node.ownerSVGElement.createSVGTransform();
t.setTranslate(dx,dy);
node.transform.baseVal.appendItem(t);
}
};
dojo.svg.scale=function(node,_2da,_2db){
if(!_2db){
var _2db=_2da;
}
if(node.transform&&node.ownerSVGElement&&node.ownerSVGElement.createSVGTransform){
var t=node.ownerSVGElement.createSVGTransform();
t.setScale(_2da,_2db);
node.transform.baseVal.appendItem(t);
}
};
dojo.svg.rotate=function(node,ang,cx,cy){
if(node.transform&&node.ownerSVGElement&&node.ownerSVGElement.createSVGTransform){
var t=node.ownerSVGElement.createSVGTransform();
if(cx==null){
t.setMatrix(t.matrix.rotate(ang));
}else{
t.setRotate(ang,cx,cy);
}
node.transform.baseVal.appendItem(t);
}
};
dojo.svg.skew=function(node,ang,axis){
var dir=axis||"x";
if(node.transform&&node.ownerSVGElement&&node.ownerSVGElement.createSVGTransform){
var t=node.ownerSVGElement.createSVGTransform();
if(dir!="x"){
t.setSkewY(ang);
}else{
t.setSkewX(ang);
}
node.transform.baseVal.appendItem(t);
}
};
dojo.svg.flip=function(node,axis){
var dir=axis||"x";
if(node.transform&&node.ownerSVGElement&&node.ownerSVGElement.createSVGTransform){
var t=node.ownerSVGElement.createSVGTransform();
t.setMatrix((dir!="x")?t.matrix.flipY():t.matrix.flipX());
node.transform.baseVal.appendItem(t);
}
};
dojo.svg.invert=function(node){
if(node.transform&&node.ownerSVGElement&&node.ownerSVGElement.createSVGTransform){
var t=node.ownerSVGElement.createSVGTransform();
t.setMatrix(t.matrix.inverse());
node.transform.baseVal.appendItem(t);
}
};
dojo.svg.applyMatrix=function(node,a,b,c,d,e,f){
if(node.transform&&node.ownerSVGElement&&node.ownerSVGElement.createSVGTransform){
var m;
if(b){
var m=node.ownerSVGElement.createSVGMatrix();
m.a=a;
m.b=b;
m.c=c;
m.d=d;
m.e=e;
m.f=f;
}else{
m=a;
}
var t=node.ownerSVGElement.createSVGTransform();
t.setMatrix(m);
node.transform.baseVal.appendItem(t);
}
};
dojo.svg.group=function(_2f6){
var p=_2f6.item(0).parentNode;
var g=document.createElementNS(this.xmlns.svg,"g");
for(var i=0;i<_2f6.length;i++){
g.appendChild(_2f6.item(i));
}
p.appendChild(g);
return g;
};
dojo.svg.ungroup=function(g){
var p=g.parentNode;
while(g.childNodes.length>0){
p.appendChild(g.childNodes.item(0));
}
p.removeChild(g);
};
dojo.svg.getGroup=function(node){
var a=this.getAncestors(node);
for(var i=0;i<a.length;i++){
if(a[i].nodeType==this.ELEMENT_NODE&&a[i].nodeName.toLowerCase()=="g"){
return a[i];
}
}
return null;
};
dojo.svg.bringToFront=function(node){
var n=this.getGroup(node)||node;
n.ownerSVGElement.appendChild(n);
};
dojo.svg.sendToBack=function(node){
var n=this.getGroup(node)||node;
n.ownerSVGElement.insertBefore(n,n.ownerSVGElement.firstChild);
};
dojo.svg.bringForward=function(node){
var n=this.getGroup(node)||node;
if(this.getLastChildElement(n.parentNode)!=n){
this.insertAfter(n,this.getNextSiblingElement(n),true);
}
};
dojo.svg.sendBackward=function(node){
var n=this.getGroup(node)||node;
if(this.getFirstChildElement(n.parentNode)!=n){
this.insertBefore(n,this.getPreviousSiblingElement(n),true);
}
};
dojo.svg.createNodesFromText=function(txt,wrap){
var _309=(new DOMParser()).parseFromString(txt,"text/xml").normalize();
if(wrap){
return [_309.firstChild.cloneNode(true)];
}
var _30a=[];
for(var x=0;x<_309.childNodes.length;x++){
_30a.push(_309.childNodes.item(x).cloneNode(true));
}
return _30a;
};
dojo.provide("dojo.charting.Axis");
dojo.charting.Axis=function(_30c,_30d,_30e){
var id="dojo-charting-axis-"+dojo.charting.Axis.count++;
this.getId=function(){
return id;
};
this.setId=function(key){
id=key;
};
this.scale=_30d||"linear";
this.label=_30c||"";
this.showLabel=true;
this.showLabels=true;
this.showLines=false;
this.showTicks=false;
this.range={upper:100,lower:0};
this.origin="min";
this._origin=null;
this.labels=_30e||[];
this._labels=[];
this.nodes={main:null,axis:null,label:null,labels:null,lines:null,ticks:null};
this._rerender=false;
};
dojo.charting.Axis.count=0;
dojo.extend(dojo.charting.Axis,{getCoord:function(val,_312,plot){
val=parseFloat(val,10);
var area=_312.getArea();
if(plot.axisX==this){
var _315=0-this.range.lower;
var min=this.range.lower+_315;
var max=this.range.upper+_315;
val+=_315;
return (val*((area.right-area.left)/max))+area.left;
}else{
var max=this.range.upper;
var min=this.range.lower;
var _315=0;
if(min<0){
_315+=Math.abs(min);
}
max+=_315;
min+=_315;
val+=_315;
var pmin=area.bottom;
var pmax=area.top;
return (((pmin-pmax)/(max-min))*(max-val))+pmax;
}
},initializeOrigin:function(_31a,_31b){
if(this._origin==null){
this._origin=this.origin;
}
if(isNaN(this._origin)){
if(this._origin.toLowerCase()=="max"){
this.origin=_31a.range[(_31b=="y")?"upper":"lower"];
}else{
if(this._origin.toLowerCase()=="min"){
this.origin=_31a.range[(_31b=="y")?"lower":"upper"];
}else{
this.origin=0;
}
}
}
},initializeLabels:function(){
this._labels=[];
if(this.labels.length==0){
this.showLabels=false;
this.showLines=false;
this.showTicks=false;
}else{
if(this.labels[0].label&&this.labels[0].value!=null){
for(var i=0;i<this.labels.length;i++){
this._labels.push(this.labels[i]);
}
}else{
if(!isNaN(this.labels[0])){
for(var i=0;i<this.labels.length;i++){
this._labels.push({label:this.labels[i],value:this.labels[i]});
}
}else{
var a=[];
for(var i=0;i<this.labels.length;i++){
a.push(this.labels[i]);
}
var s=a.shift();
this._labels.push({label:s,value:this.range.lower});
if(a.length>0){
var s=a.pop();
this._labels.push({label:s,value:this.range.upper});
}
if(a.length>0){
var _31f=this.range.upper-this.range.lower;
var step=_31f/(this.labels.length-1);
for(var i=1;i<=a.length;i++){
this._labels.push({label:a[i-1],value:this.range.lower+(step*i)});
}
}
}
}
}
},initialize:function(_321,plot,_323,_324){
this.destroy();
this.initializeOrigin(_323,_324);
this.initializeLabels();
var node=this.render(_321,plot,_323,_324);
return node;
},destroy:function(){
for(var p in this.nodes){
while(this.nodes[p]&&this.nodes[p].childNodes.length>0){
this.nodes[p].removeChild(this.nodes[p].childNodes[0]);
}
if(this.nodes[p]&&this.nodes[p].parentNode){
this.nodes[p].parentNode.removeChild(this.nodes[p]);
}
this.nodes[p]=null;
}
}});
dojo.requireIf(dojo.render.svg.capable,"dojo.charting.svg.Axis");
dojo.requireIf(dojo.render.vml.capable,"dojo.charting.vml.Axis");
dojo.provide("dojo.charting.svg.Axis");
if(dojo.render.svg.capable){
dojo.extend(dojo.charting.Axis,{renderLines:function(_327,plot,_329){
if(this.nodes.lines){
while(this.nodes.lines.childNodes.length>0){
this.nodes.lines.removeChild(this.nodes.lines.childNodes[0]);
}
if(this.nodes.lines.parentNode){
this.nodes.lines.parentNode.removeChild(this.nodes.lines);
this.nodes.lines=null;
}
}
var area=_327.getArea();
var g=this.nodes.lines=document.createElementNS(dojo.svg.xmlns.svg,"g");
g.setAttribute("id",this.getId()+"-lines");
for(var i=0;i<this._labels.length;i++){
if(this._labels[i].value==this.origin){
continue;
}
var v=this.getCoord(this._labels[i].value,_327,plot);
var l=document.createElementNS(dojo.svg.xmlns.svg,"line");
l.setAttribute("style","stroke:#999;stroke-width:1px;stroke-dasharray:1,4;");
if(_329=="x"){
l.setAttribute("y1",area.top);
l.setAttribute("y2",area.bottom);
l.setAttribute("x1",v);
l.setAttribute("x2",v);
}else{
if(_329=="y"){
l.setAttribute("y1",v);
l.setAttribute("y2",v);
l.setAttribute("x1",area.left);
l.setAttribute("x2",area.right);
}
}
g.appendChild(l);
}
return g;
},renderTicks:function(_32f,plot,_331,_332){
if(this.nodes.ticks){
while(this.nodes.ticks.childNodes.length>0){
this.nodes.ticks.removeChild(this.nodes.ticks.childNodes[0]);
}
if(this.nodes.ticks.parentNode){
this.nodes.ticks.parentNode.removeChild(this.nodes.ticks);
this.nodes.ticks=null;
}
}
var g=this.nodes.ticks=document.createElementNS(dojo.svg.xmlns.svg,"g");
g.setAttribute("id",this.getId()+"-ticks");
for(var i=0;i<this._labels.length;i++){
var v=this.getCoord(this._labels[i].value,_32f,plot);
var l=document.createElementNS(dojo.svg.xmlns.svg,"line");
l.setAttribute("style","stroke:#000;stroke-width:1pt;");
if(_331=="x"){
l.setAttribute("y1",_332);
l.setAttribute("y2",_332+3);
l.setAttribute("x1",v);
l.setAttribute("x2",v);
}else{
if(_331=="y"){
l.setAttribute("y1",v);
l.setAttribute("y2",v);
l.setAttribute("x1",_332-2);
l.setAttribute("x2",_332+2);
}
}
g.appendChild(l);
}
return g;
},renderLabels:function(_337,plot,_339,_33a,_33b,_33c){
function createLabel(_33d,x,y,_340,_341){
var text=document.createElementNS(dojo.svg.xmlns.svg,"text");
text.setAttribute("x",x);
text.setAttribute("y",(_339=="x"?y:y+2));
text.setAttribute("style","text-anchor:"+_341+";font-family:sans-serif;font-size:"+_340+"px;fill:#000;");
text.appendChild(document.createTextNode(_33d));
return text;
}
if(this.nodes.labels){
while(this.nodes.labels.childNodes.length>0){
this.nodes.labels.removeChild(this.nodes.labels.childNodes[0]);
}
if(this.nodes.labels.parentNode){
this.nodes.labels.parentNode.removeChild(this.nodes.labels);
this.nodes.labels=null;
}
}
var g=this.nodes.labels=document.createElementNS(dojo.svg.xmlns.svg,"g");
g.setAttribute("id",this.getId()+"-labels");
for(var i=0;i<this._labels.length;i++){
var v=this.getCoord(this._labels[i].value,_337,plot);
if(_339=="x"){
g.appendChild(createLabel(this._labels[i].label,v,_33a,_33b,_33c));
}else{
if(_339=="y"){
g.appendChild(createLabel(this._labels[i].label,_33a,v,_33b,_33c));
}
}
}
return g;
},render:function(_346,plot,_348,_349){
if(!this._rerender&&this.nodes.main){
return this.nodes.main;
}
this._rerender=false;
var area=_346.getArea();
var _34b=1;
var _34c="stroke:#000;stroke-width:"+_34b+"px;";
var _34d=10;
var _34e=_348.getCoord(this.origin,_346,plot);
this.nodes.main=document.createElementNS(dojo.svg.xmlns.svg,"g");
var g=this.nodes.main;
g.setAttribute("id",this.getId());
var line=this.nodes.axis=document.createElementNS(dojo.svg.xmlns.svg,"line");
if(_349=="x"){
line.setAttribute("y1",_34e);
line.setAttribute("y2",_34e);
line.setAttribute("x1",area.left-_34b);
line.setAttribute("x2",area.right+_34b);
line.setAttribute("style",_34c);
var y=_34e+_34d+2;
if(this.showLines){
g.appendChild(this.renderLines(_346,plot,_349,y));
}
if(this.showTicks){
g.appendChild(this.renderTicks(_346,plot,_349,_34e));
}
if(this.showLabels){
g.appendChild(this.renderLabels(_346,plot,_349,y,_34d,"middle"));
}
if(this.showLabel&&this.label){
var x=_346.size.width/2;
var text=document.createElementNS(dojo.svg.xmlns.svg,"text");
text.setAttribute("x",x);
text.setAttribute("y",(_34e+(_34d*2)+(_34d/2)));
text.setAttribute("style","text-anchor:middle;font-family:sans-serif;font-weight:bold;font-size:"+(_34d+2)+"px;fill:#000;");
text.appendChild(document.createTextNode(this.label));
g.appendChild(text);
}
}else{
line.setAttribute("x1",_34e);
line.setAttribute("x2",_34e);
line.setAttribute("y1",area.top);
line.setAttribute("y2",area.bottom);
line.setAttribute("style",_34c);
var _354=this.origin==_348.range.upper;
var x=_34e+(_354?4:-4);
var _355=_354?"start":"end";
if(this.showLines){
g.appendChild(this.renderLines(_346,plot,_349,x));
}
if(this.showTicks){
g.appendChild(this.renderTicks(_346,plot,_349,_34e));
}
if(this.showLabels){
g.appendChild(this.renderLabels(_346,plot,_349,x,_34d,_355));
}
if(this.showLabel&&this.label){
var x=_354?(_34e+(_34d*2)+(_34d/2)):(_34e-(_34d*4));
var y=_346.size.height/2;
var text=document.createElementNS(dojo.svg.xmlns.svg,"text");
text.setAttribute("x",x);
text.setAttribute("y",y);
text.setAttribute("transform","rotate(90, "+x+", "+y+")");
text.setAttribute("style","text-anchor:middle;font-family:sans-serif;font-weight:bold;font-size:"+(_34d+2)+"px;fill:#000;");
text.appendChild(document.createTextNode(this.label));
g.appendChild(text);
}
}
g.appendChild(line);
return g;
}});
}
dojo.provide("dojo.charting.vml.Axis");
if(dojo.render.vml.capable){
dojo.extend(dojo.charting.Axis,{renderLines:function(_356,plot,_358){
if(this.nodes.lines){
while(this.nodes.lines.childNodes.length>0){
this.nodes.lines.removeChild(this.nodes.lines.childNodes[0]);
}
if(this.nodes.lines.parentNode){
this.nodes.lines.parentNode.removeChild(this.nodes.lines);
this.nodes.lines=null;
}
}
var area=_356.getArea();
var g=this.nodes.lines=document.createElement("div");
g.setAttribute("id",this.getId()+"-lines");
for(var i=0;i<this._labels.length;i++){
if(this._labels[i].value==this.origin){
continue;
}
var v=this.getCoord(this._labels[i].value,_356,plot);
var l=document.createElement("v:line");
var str=document.createElement("v:stroke");
str.dashstyle="dot";
l.appendChild(str);
l.setAttribute("strokecolor","#666");
l.setAttribute("strokeweight","1px");
var s=l.style;
s.position="absolute";
s.top="0px";
s.left="0px";
s.antialias="false";
if(_358=="x"){
l.setAttribute("from",v+"px,"+area.top+"px");
l.setAttribute("to",v+"px,"+area.bottom+"px");
}else{
if(_358=="y"){
l.setAttribute("from",area.left+"px,"+v+"px");
l.setAttribute("to",area.right+"px,"+v+"px");
}
}
g.appendChild(l);
}
return g;
},renderTicks:function(_360,plot,_362,_363){
if(this.nodes.ticks){
while(this.nodes.ticks.childNodes.length>0){
this.nodes.ticks.removeChild(this.nodes.ticks.childNodes[0]);
}
if(this.nodes.ticks.parentNode){
this.nodes.ticks.parentNode.removeChild(this.nodes.ticks);
this.nodes.ticks=null;
}
}
var g=this.nodes.ticks=document.createElement("div");
g.setAttribute("id",this.getId()+"-ticks");
for(var i=0;i<this._labels.length;i++){
var v=this.getCoord(this._labels[i].value,_360,plot);
var l=document.createElement("v:line");
l.setAttribute("strokecolor","#000");
l.setAttribute("strokeweight","1px");
var s=l.style;
s.position="absolute";
s.top="0px";
s.left="0px";
s.antialias="false";
if(_362=="x"){
l.setAttribute("from",v+"px,"+_363+"px");
l.setAttribute("to",v+"px,"+(_363+3)+"px");
}else{
if(_362=="y"){
l.setAttribute("from",(_363-2)+"px,"+v+"px");
l.setAttribute("to",(_363+2)+"px,"+v+"px");
}
}
g.appendChild(l);
}
return g;
},renderLabels:function(_369,plot,_36b,_36c,_36d,_36e){
function createLabel(_36f,x,y,_372,_373){
var text=document.createElement("div");
var s=text.style;
text.innerHTML=_36f;
s.fontSize=_372+"px";
s.fontFamily="sans-serif";
s.position="absolute";
s.top=y+"px";
if(_373=="center"){
s.left=x+"px";
s.textAlign="center";
}else{
if(_373=="left"){
s.left=x+"px";
s.textAlign="left";
}else{
if(_373=="right"){
s.right=x+"px";
s.textAlign="right";
}
}
}
return text;
}
if(this.nodes.labels){
while(this.nodes.labels.childNodes.length>0){
this.nodes.labels.removeChild(this.nodes.labels.childNodes[0]);
}
if(this.nodes.labels.parentNode){
this.nodes.labels.parentNode.removeChild(this.nodes.labels);
this.nodes.labels=null;
}
}
var g=this.nodes.labels=document.createElement("div");
g.setAttribute("id",this.getId()+"-labels");
for(var i=0;i<this._labels.length;i++){
var v=this.getCoord(this._labels[i].value,_369,plot);
if(_36b=="x"){
var node=createLabel(this._labels[i].label,v,_36c,_36d,_36e);
document.body.appendChild(node);
node.style.left=v-(node.offsetWidth/2)+"px";
g.appendChild(node);
}else{
if(_36b=="y"){
var node=createLabel(this._labels[i].label,_36c,v,_36d,_36e);
document.body.appendChild(node);
node.style.top=v-(node.offsetHeight/2)+"px";
g.appendChild(node);
}
}
}
return g;
},render:function(_37a,plot,_37c,_37d){
if(!this._rerender&&this.nodes.main){
return this.nodes.main;
}
this._rerender=false;
var area=_37a.getArea();
var _37f=1;
var _380="stroke:#000;stroke-width:"+_37f+"px;";
var _381=10;
var _382=_37c.getCoord(this.origin,_37a,plot);
var g=this.nodes.main=document.createElement("div");
g.setAttribute("id",this.getId());
var line=this.nodes.axis=document.createElement("v:line");
line.setAttribute("strokecolor","#000");
line.setAttribute("strokeweight",_37f+"px");
var s=line.style;
s.position="absolute";
s.top="0px";
s.left="0px";
s.antialias="false";
if(_37d=="x"){
line.setAttribute("from",area.left+"px,"+_382+"px");
line.setAttribute("to",area.right+"px,"+_382+"px");
var y=_382+Math.floor(_381/2);
if(this.showLines){
g.appendChild(this.renderLines(_37a,plot,_37d,y));
}
if(this.showTicks){
g.appendChild(this.renderTicks(_37a,plot,_37d,_382));
}
if(this.showLabels){
g.appendChild(this.renderLabels(_37a,plot,_37d,y,_381,"center"));
}
if(this.showLabel&&this.label){
var x=_37a.size.width/2;
var y=_382+Math.round(_381*1.5);
var text=document.createElement("div");
var s=text.style;
text.innerHTML=this.label;
s.fontSize=(_381+2)+"px";
s.fontFamily="sans-serif";
s.fontWeight="bold";
s.position="absolute";
s.top=y+"px";
s.left=x+"px";
s.textAlign="center";
document.body.appendChild(text);
text.style.left=x-(text.offsetWidth/2)+"px";
g.appendChild(text);
}
}else{
line.setAttribute("from",_382+"px,"+area.top+"px");
line.setAttribute("to",_382+"px,"+area.bottom+"px");
var _389=this.origin==_37c.range.upper;
var x=_382+4;
var _38a="left";
if(!_389){
x=area.right-_382+_381+4;
_38a="right";
if(_382==area.left){
x+=(_381*2)-(_381/2);
}
}
if(this.showLines){
g.appendChild(this.renderLines(_37a,plot,_37d,x));
}
if(this.showTicks){
g.appendChild(this.renderTicks(_37a,plot,_37d,_382));
}
if(this.showLabels){
g.appendChild(this.renderLabels(_37a,plot,_37d,x,_381,_38a));
}
if(this.showLabel&&this.label){
x+=(_381*2)-2;
var y=_37a.size.height/2;
var text=document.createElement("div");
var s=text.style;
text.innerHTML=this.label;
s.fontSize=(_381+2)+"px";
s.fontFamily="sans-serif";
s.fontWeight="bold";
s.position="absolute";
s.height=_37a.size.height+"px";
s.writingMode="tb-rl";
s.textAlign="center";
s[_38a]=x+"px";
document.body.appendChild(text);
s.top=y-(text.offsetHeight/2)+"px";
g.appendChild(text);
}
}
g.appendChild(line);
return g;
}});
}
dojo.provide("dojo.charting.Plotters");
dojo.requireIf(dojo.render.svg.capable,"dojo.charting.svg.Plotters");
dojo.requireIf(dojo.render.vml.capable,"dojo.charting.vml.Plotters");
dojo.provide("dojo.charting.svg.Plotters");
if(dojo.render.svg.capable){
dojo.mixin(dojo.charting.Plotters,{Bar:function(_38b,plot,_38d,_38e){
var area=_38b.getArea();
var _390=document.createElementNS(dojo.svg.xmlns.svg,"g");
var n=plot.series.length;
var data=[];
for(var i=0;i<n;i++){
var tmp=plot.series[i].data.evaluate(_38d);
data.push(tmp);
}
var _395=8;
var _396=data[0].length;
if(_396==0){
return _390;
}
var _397=((area.right-area.left)-(_395*(_396-1)))/_396;
var _398=_397/n;
var _399=plot.axisY.getCoord(plot.axisX.origin,_38b,plot);
for(var i=0;i<_396;i++){
var _39a=area.left+(_397*i)+(_395*i);
for(var j=0;j<n;j++){
var _39c=data[j][i].y;
var yA=_399;
var x=_39a+(_398*j);
var y=plot.axisY.getCoord(_39c,_38b,plot);
var h=Math.abs(yA-y);
if(_39c<plot.axisX.origin){
yA=y;
y=_399;
}
var bar=document.createElementNS(dojo.svg.xmlns.svg,"rect");
bar.setAttribute("fill",data[j][i].series.color);
bar.setAttribute("stroke-width","0");
bar.setAttribute("x",x);
bar.setAttribute("y",y);
bar.setAttribute("width",_398);
bar.setAttribute("height",h);
bar.setAttribute("fill-opacity","0.6");
if(_38e){
_38e(bar,data[j][i].src);
}
_390.appendChild(bar);
}
}
return _390;
},HorizontalBar:function(_3a2,plot,_3a4,_3a5){
var area=_3a2.getArea();
var _3a7=document.createElementNS(dojo.svg.xmlns.svg,"g");
var n=plot.series.length;
var data=[];
for(var i=0;i<n;i++){
var tmp=plot.series[i].data.evaluate(_3a4);
data.push(tmp);
}
var _3ac=6;
var _3ad=data[0].length;
if(_3ad==0){
return _3a7;
}
var h=((area.bottom-area.top)-(_3ac*(_3ad-1)))/_3ad;
var barH=h/n;
var _3b0=plot.axisX.getCoord(0,_3a2,plot);
for(var i=0;i<_3ad;i++){
var _3b1=area.top+(h*i)+(_3ac*i);
for(var j=0;j<n;j++){
var _3b3=data[j][i].y;
var y=_3b1+(barH*j);
var xA=_3b0;
var x=plot.axisX.getCoord(_3b3,_3a2,plot);
var w=Math.abs(x-xA);
if(_3b3>0){
x=_3b0;
}
var bar=document.createElementNS(dojo.svg.xmlns.svg,"rect");
bar.setAttribute("fill",data[j][i].series.color);
bar.setAttribute("stroke-width","0");
bar.setAttribute("x",xA);
bar.setAttribute("y",y);
bar.setAttribute("width",w);
bar.setAttribute("height",barH);
bar.setAttribute("fill-opacity","0.6");
if(_3a5){
_3a5(bar,data[j][i].src);
}
_3a7.appendChild(bar);
}
}
return _3a7;
},Gantt:function(_3b9,plot,_3bb,_3bc){
var area=_3b9.getArea();
var _3be=document.createElementNS(dojo.svg.xmlns.svg,"g");
var n=plot.series.length;
var data=[];
for(var i=0;i<n;i++){
var tmp=plot.series[i].data.evaluate(_3bb);
data.push(tmp);
}
var _3c3=2;
var _3c4=data[0].length;
if(_3c4==0){
return _3be;
}
var h=((area.bottom-area.top)-(_3c3*(_3c4-1)))/_3c4;
var barH=h/n;
for(var i=0;i<_3c4;i++){
var _3c7=area.top+(h*i)+(_3c3*i);
for(var j=0;j<n;j++){
var high=data[j][i].high;
var low=data[j][i].low;
if(low>high){
var t=high;
high=low;
low=t;
}
var x=plot.axisX.getCoord(low,_3b9,plot);
var w=plot.axisX.getCoord(high,_3b9,plot)-x;
var y=_3c7+(barH*j);
var bar=document.createElementNS(dojo.svg.xmlns.svg,"rect");
bar.setAttribute("fill",data[j][i].series.color);
bar.setAttribute("stroke-width","0");
bar.setAttribute("x",x);
bar.setAttribute("y",y);
bar.setAttribute("width",w);
bar.setAttribute("height",barH);
bar.setAttribute("fill-opacity","0.6");
if(_3bc){
_3bc(bar,data[j][i].src);
}
_3be.appendChild(bar);
}
}
return _3be;
},StackedArea:function(_3d0,plot,_3d2,_3d3){
var area=_3d0.getArea();
var _3d5=document.createElementNS(dojo.svg.xmlns.svg,"g");
var n=plot.series.length;
var data=[];
var _3d8=[];
for(var i=0;i<n;i++){
var tmp=plot.series[i].data.evaluate(_3d2);
for(var j=0;j<tmp.length;j++){
if(i==0){
_3d8.push(tmp[j].y);
}else{
_3d8[j]+=tmp[j].y;
}
tmp[j].y=_3d8[j];
}
data.push(tmp);
}
for(var i=n-1;i>=0;i--){
var path=document.createElementNS(dojo.svg.xmlns.svg,"path");
path.setAttribute("fill",data[i][0].series.color);
path.setAttribute("fill-opacity","0.4");
path.setAttribute("stroke",data[i][0].series.color);
path.setAttribute("stroke-width","1");
path.setAttribute("stroke-opacity","0.85");
var cmd=[];
var r=3;
for(var j=0;j<data[i].length;j++){
var _3df=data[i];
var x=plot.axisX.getCoord(_3df[j].x,_3d0,plot);
var y=plot.axisY.getCoord(_3df[j].y,_3d0,plot);
if(j==0){
cmd.push("M");
}else{
cmd.push("L");
}
cmd.push(x+","+y);
var c=document.createElementNS(dojo.svg.xmlns.svg,"circle");
c.setAttribute("cx",x);
c.setAttribute("cy",y);
c.setAttribute("r","3");
c.setAttribute("fill",_3df[j].series.color);
c.setAttribute("fill-opacity","0.6");
c.setAttribute("stroke-width","1");
c.setAttribute("stroke-opacity","0.85");
_3d5.appendChild(c);
if(_3d3){
_3d3(c,data[i].src);
}
}
if(i==0){
cmd.push("L");
cmd.push(x+","+plot.axisY.getCoord(plot.axisX.origin,_3d0,plot));
cmd.push("L");
cmd.push(plot.axisX.getCoord(data[0][0].x,_3d0,plot)+","+plot.axisY.getCoord(plot.axisX.origin,_3d0,plot));
cmd.push("Z");
}else{
var _3df=data[i-1];
cmd.push("L");
cmd.push(x+","+Math.round(plot.axisY.getCoord(_3df[_3df.length-1].y,_3d0,plot)));
for(var j=_3df.length-2;j>=0;j--){
var x=plot.axisX.getCoord(_3df[j].x,_3d0,plot);
var y=plot.axisY.getCoord(_3df[j].y,_3d0,plot);
cmd.push("L");
cmd.push(x+","+y);
}
}
path.setAttribute("d",cmd.join(" ")+" Z");
_3d5.appendChild(path);
}
return _3d5;
},StackedCurvedArea:function(_3e3,plot,_3e5,_3e6){
var _3e7=3;
var area=_3e3.getArea();
var _3e9=document.createElementNS(dojo.svg.xmlns.svg,"g");
var n=plot.series.length;
var data=[];
var _3ec=[];
for(var i=0;i<n;i++){
var tmp=plot.series[i].data.evaluate(_3e5);
for(var j=0;j<tmp.length;j++){
if(i==0){
_3ec.push(tmp[j].y);
}else{
_3ec[j]+=tmp[j].y;
}
tmp[j].y=_3ec[j];
}
data.push(tmp);
}
for(var i=n-1;i>=0;i--){
var path=document.createElementNS(dojo.svg.xmlns.svg,"path");
path.setAttribute("fill",data[i][0].series.color);
path.setAttribute("fill-opacity","0.4");
path.setAttribute("stroke",data[i][0].series.color);
path.setAttribute("stroke-width","1");
path.setAttribute("stroke-opacity","0.85");
var cmd=[];
var r=3;
for(var j=0;j<data[i].length;j++){
var _3f3=data[i];
var x=plot.axisX.getCoord(_3f3[j].x,_3e3,plot);
var y=plot.axisY.getCoord(_3f3[j].y,_3e3,plot);
var dx=area.left+1;
var dy=area.bottom;
if(j>0){
dx=x-plot.axisX.getCoord(_3f3[j-1].x,_3e3,plot);
dy=plot.axisY.getCoord(_3f3[j-1].y,_3e3,plot);
}
if(j==0){
cmd.push("M");
}else{
cmd.push("C");
var cx=x-(_3e7-1)*(dx/_3e7);
cmd.push(cx+","+dy);
cx=x-(dx/_3e7);
cmd.push(cx+","+y);
}
cmd.push(x+","+y);
var c=document.createElementNS(dojo.svg.xmlns.svg,"circle");
c.setAttribute("cx",x);
c.setAttribute("cy",y);
c.setAttribute("r","3");
c.setAttribute("fill",_3f3[j].series.color);
c.setAttribute("fill-opacity","0.6");
c.setAttribute("stroke-width","1");
c.setAttribute("stroke-opacity","0.85");
_3e9.appendChild(c);
if(_3e6){
_3e6(c,data[i].src);
}
}
if(i==0){
cmd.push("L");
cmd.push(x+","+plot.axisY.getCoord(plot.axisX.origin,_3e3,plot));
cmd.push("L");
cmd.push(plot.axisX.getCoord(data[0][0].x,_3e3,plot)+","+plot.axisY.getCoord(plot.axisX.origin,_3e3,plot));
cmd.push("Z");
}else{
var _3f3=data[i-1];
cmd.push("L");
cmd.push(x+","+Math.round(plot.axisY.getCoord(_3f3[_3f3.length-1].y,_3e3,plot)));
for(var j=_3f3.length-2;j>=0;j--){
var x=plot.axisX.getCoord(_3f3[j].x,_3e3,plot);
var y=plot.axisY.getCoord(_3f3[j].y,_3e3,plot);
var dx=x-plot.axisX.getCoord(_3f3[j+1].x,_3e3,plot);
var dy=plot.axisY.getCoord(_3f3[j+1].y,_3e3,plot);
cmd.push("C");
var cx=x-(_3e7-1)*(dx/_3e7);
cmd.push(cx+","+dy);
cx=x-(dx/_3e7);
cmd.push(cx+","+y);
cmd.push(x+","+y);
}
}
path.setAttribute("d",cmd.join(" ")+" Z");
_3e9.appendChild(path);
}
return _3e9;
},DataBar:function(data,_3fb,plot,_3fd){
var area=_3fb.getArea();
var _3ff=document.createElementNS(dojo.svg.xmlns.svg,"g");
var n=data.length;
var w=(area.right-area.left)/(plot.axisX.range.upper-plot.axisX.range.lower);
var _402=plot.axisY.getCoord(plot.axisX.origin,_3fb,plot);
for(var i=0;i<n;i++){
var _404=data[i].y;
var yA=_402;
var x=plot.axisX.getCoord(data[i].x,_3fb,plot)-(w/2);
var y=plot.axisY.getCoord(_404,_3fb,plot);
var h=Math.abs(yA-y);
if(_404<plot.axisX.origin){
yA=y;
y=_402;
}
var bar=document.createElementNS(dojo.svg.xmlns.svg,"rect");
bar.setAttribute("fill",data[i].series.color);
bar.setAttribute("stroke-width","0");
bar.setAttribute("x",x);
bar.setAttribute("y",y);
bar.setAttribute("width",w);
bar.setAttribute("height",h);
bar.setAttribute("fill-opacity","0.6");
if(_3fd){
_3fd(bar,data[i].src);
}
_3ff.appendChild(bar);
}
return _3ff;
},Line:function(data,_40b,plot,_40d){
var area=_40b.getArea();
var line=document.createElementNS(dojo.svg.xmlns.svg,"g");
if(data.length==0){
return line;
}
var path=document.createElementNS(dojo.svg.xmlns.svg,"path");
line.appendChild(path);
path.setAttribute("fill","none");
path.setAttribute("stroke",data[0].series.color);
path.setAttribute("stroke-width","2");
path.setAttribute("stroke-opacity","0.85");
if(data[0].series.label!=null){
path.setAttribute("title",data[0].series.label);
}
var cmd=[];
for(var i=0;i<data.length;i++){
var x=plot.axisX.getCoord(data[i].x,_40b,plot);
var y=plot.axisY.getCoord(data[i].y,_40b,plot);
if(i==0){
cmd.push("M");
}else{
cmd.push("L");
}
cmd.push(x+","+y);
var c=document.createElementNS(dojo.svg.xmlns.svg,"circle");
c.setAttribute("cx",x);
c.setAttribute("cy",y);
c.setAttribute("r","3");
c.setAttribute("fill",data[i].series.color);
c.setAttribute("fill-opacity","0.6");
c.setAttribute("stroke-width","1");
c.setAttribute("stroke-opacity","0.85");
line.appendChild(c);
if(_40d){
_40d(c,data[i].src);
}
}
path.setAttribute("d",cmd.join(" "));
return line;
},CurvedLine:function(data,_417,plot,_419){
var _41a=3;
var area=_417.getArea();
var line=document.createElementNS(dojo.svg.xmlns.svg,"g");
if(data.length==0){
return line;
}
var path=document.createElementNS(dojo.svg.xmlns.svg,"path");
line.appendChild(path);
path.setAttribute("fill","none");
path.setAttribute("stroke",data[0].series.color);
path.setAttribute("stroke-width","2");
path.setAttribute("stroke-opacity","0.85");
if(data[0].series.label!=null){
path.setAttribute("title",data[0].series.label);
}
var cmd=[];
for(var i=0;i<data.length;i++){
var x=plot.axisX.getCoord(data[i].x,_417,plot);
var y=plot.axisY.getCoord(data[i].y,_417,plot);
var dx=area.left+1;
var dy=area.bottom;
if(i>0){
dx=x-plot.axisX.getCoord(data[i-1].x,_417,plot);
dy=plot.axisY.getCoord(data[i-1].y,_417,plot);
}
if(i==0){
cmd.push("M");
}else{
cmd.push("C");
var cx=x-(_41a-1)*(dx/_41a);
cmd.push(cx+","+dy);
cx=x-(dx/_41a);
cmd.push(cx+","+y);
}
cmd.push(x+","+y);
var c=document.createElementNS(dojo.svg.xmlns.svg,"circle");
c.setAttribute("cx",x);
c.setAttribute("cy",y);
c.setAttribute("r","3");
c.setAttribute("fill",data[i].series.color);
c.setAttribute("fill-opacity","0.6");
c.setAttribute("stroke-width","1");
c.setAttribute("stroke-opacity","0.85");
line.appendChild(c);
if(_419){
_419(c,data[i].src);
}
}
path.setAttribute("d",cmd.join(" "));
return line;
},Area:function(data,_427,plot,_429){
var area=_427.getArea();
var line=document.createElementNS(dojo.svg.xmlns.svg,"g");
if(data.length==0){
return line;
}
var path=document.createElementNS(dojo.svg.xmlns.svg,"path");
line.appendChild(path);
path.setAttribute("fill",data[0].series.color);
path.setAttribute("fill-opacity","0.4");
path.setAttribute("stroke",data[0].series.color);
path.setAttribute("stroke-width","1");
path.setAttribute("stroke-opacity","0.85");
if(data[0].series.label!=null){
path.setAttribute("title",data[0].series.label);
}
var cmd=[];
for(var i=0;i<data.length;i++){
var x=plot.axisX.getCoord(data[i].x,_427,plot);
var y=plot.axisY.getCoord(data[i].y,_427,plot);
if(i==0){
cmd.push("M");
}else{
cmd.push("L");
}
cmd.push(x+","+y);
var c=document.createElementNS(dojo.svg.xmlns.svg,"circle");
c.setAttribute("cx",x);
c.setAttribute("cy",y);
c.setAttribute("r","3");
c.setAttribute("fill",data[i].series.color);
c.setAttribute("fill-opacity","0.6");
c.setAttribute("stroke-width","1");
c.setAttribute("stroke-opacity","0.85");
line.appendChild(c);
if(_429){
_429(c,data[i].src);
}
}
cmd.push("L");
cmd.push(x+","+plot.axisY.getCoord(plot.axisX.origin,_427,plot));
cmd.push("L");
cmd.push(plot.axisX.getCoord(data[0].x,_427,plot)+","+plot.axisY.getCoord(plot.axisX.origin,_427,plot));
cmd.push("Z");
path.setAttribute("d",cmd.join(" "));
return line;
},CurvedArea:function(data,_433,plot,_435){
var _436=3;
var area=_433.getArea();
var line=document.createElementNS(dojo.svg.xmlns.svg,"g");
if(data.length==0){
return line;
}
var path=document.createElementNS(dojo.svg.xmlns.svg,"path");
line.appendChild(path);
path.setAttribute("fill",data[0].series.color);
path.setAttribute("fill-opacity","0.4");
path.setAttribute("stroke",data[0].series.color);
path.setAttribute("stroke-width","1");
path.setAttribute("stroke-opacity","0.85");
if(data[0].series.label!=null){
path.setAttribute("title",data[0].series.label);
}
var cmd=[];
for(var i=0;i<data.length;i++){
var x=plot.axisX.getCoord(data[i].x,_433,plot);
var y=plot.axisY.getCoord(data[i].y,_433,plot);
var dx=area.left+1;
var dy=area.bottom;
if(i>0){
dx=x-plot.axisX.getCoord(data[i-1].x,_433,plot);
dy=plot.axisY.getCoord(data[i-1].y,_433,plot);
}
if(i==0){
cmd.push("M");
}else{
cmd.push("C");
var cx=x-(_436-1)*(dx/_436);
cmd.push(cx+","+dy);
cx=x-(dx/_436);
cmd.push(cx+","+y);
}
cmd.push(x+","+y);
var c=document.createElementNS(dojo.svg.xmlns.svg,"circle");
c.setAttribute("cx",x);
c.setAttribute("cy",y);
c.setAttribute("r","3");
c.setAttribute("fill",data[i].series.color);
c.setAttribute("fill-opacity","0.6");
c.setAttribute("stroke-width","1");
c.setAttribute("stroke-opacity","0.85");
line.appendChild(c);
if(_435){
_435(c,data[i].src);
}
}
cmd.push("L");
cmd.push(x+","+plot.axisY.getCoord(plot.axisX.origin,_433,plot));
cmd.push("L");
cmd.push(plot.axisX.getCoord(data[0].x,_433,plot)+","+plot.axisY.getCoord(plot.axisX.origin,_433,plot));
cmd.push("Z");
path.setAttribute("d",cmd.join(" "));
return line;
},HighLow:function(data,_443,plot,_445){
var area=_443.getArea();
var _447=document.createElementNS(dojo.svg.xmlns.svg,"g");
var n=data.length;
var part=((area.right-area.left)/(plot.axisX.range.upper-plot.axisX.range.lower))/4;
var w=part*2;
for(var i=0;i<n;i++){
var high=data[i].high;
var low=data[i].low;
if(low>high){
var t=low;
low=high;
high=t;
}
var x=plot.axisX.getCoord(data[i].x,_443,plot)-(w/2);
var y=plot.axisY.getCoord(high,_443,plot);
var h=plot.axisY.getCoord(low,_443,plot)-y;
var bar=document.createElementNS(dojo.svg.xmlns.svg,"rect");
bar.setAttribute("fill",data[i].series.color);
bar.setAttribute("stroke-width","0");
bar.setAttribute("x",x);
bar.setAttribute("y",y);
bar.setAttribute("width",w);
bar.setAttribute("height",h);
bar.setAttribute("fill-opacity","0.6");
if(_445){
_445(bar,data[i].src);
}
_447.appendChild(bar);
}
return _447;
},HighLowClose:function(data,_454,plot,_456){
var area=_454.getArea();
var _458=document.createElementNS(dojo.svg.xmlns.svg,"g");
var n=data.length;
var part=((area.right-area.left)/(plot.axisX.range.upper-plot.axisX.range.lower))/4;
var w=part*2;
for(var i=0;i<n;i++){
var high=data[i].high;
var low=data[i].low;
if(low>high){
var t=low;
low=high;
high=t;
}
var c=data[i].close;
var x=plot.axisX.getCoord(data[i].x,_454,plot)-(w/2);
var y=plot.axisY.getCoord(high,_454,plot);
var h=plot.axisY.getCoord(low,_454,plot)-y;
var _464=plot.axisY.getCoord(c,_454,plot);
var g=document.createElementNS(dojo.svg.xmlns.svg,"g");
var bar=document.createElementNS(dojo.svg.xmlns.svg,"rect");
bar.setAttribute("fill",data[i].series.color);
bar.setAttribute("stroke-width","0");
bar.setAttribute("x",x);
bar.setAttribute("y",y);
bar.setAttribute("width",w);
bar.setAttribute("height",h);
bar.setAttribute("fill-opacity","0.6");
g.appendChild(bar);
var line=document.createElementNS(dojo.svg.xmlns.svg,"line");
line.setAttribute("x1",x);
line.setAttribute("x2",x+w+(part*2));
line.setAttribute("y1",_464);
line.setAttribute("y2",_464);
line.setAttribute("style","stroke:"+data[i].series.color+";stroke-width:1px;stroke-opacity:0.6;");
g.appendChild(line);
if(_456){
_456(g,data[i].src);
}
_458.appendChild(g);
}
return _458;
},HighLowOpenClose:function(data,_469,plot,_46b){
var area=_469.getArea();
var _46d=document.createElementNS(dojo.svg.xmlns.svg,"g");
var n=data.length;
var part=((area.right-area.left)/(plot.axisX.range.upper-plot.axisX.range.lower))/4;
var w=part*2;
for(var i=0;i<n;i++){
var high=data[i].high;
var low=data[i].low;
if(low>high){
var t=low;
low=high;
high=t;
}
var o=data[i].open;
var c=data[i].close;
var x=plot.axisX.getCoord(data[i].x,_469,plot)-(w/2);
var y=plot.axisY.getCoord(high,_469,plot);
var h=plot.axisY.getCoord(low,_469,plot)-y;
var open=plot.axisY.getCoord(o,_469,plot);
var _47b=plot.axisY.getCoord(c,_469,plot);
var g=document.createElementNS(dojo.svg.xmlns.svg,"g");
var bar=document.createElementNS(dojo.svg.xmlns.svg,"rect");
bar.setAttribute("fill",data[i].series.color);
bar.setAttribute("stroke-width","0");
bar.setAttribute("x",x);
bar.setAttribute("y",y);
bar.setAttribute("width",w);
bar.setAttribute("height",h);
bar.setAttribute("fill-opacity","0.6");
g.appendChild(bar);
var line=document.createElementNS(dojo.svg.xmlns.svg,"line");
line.setAttribute("x1",x-(part*2));
line.setAttribute("x2",x+w);
line.setAttribute("y1",open);
line.setAttribute("y2",open);
line.setAttribute("style","stroke:"+data[i].series.color+";stroke-width:1px;stroke-opacity:0.6;");
g.appendChild(line);
var line=document.createElementNS(dojo.svg.xmlns.svg,"line");
line.setAttribute("x1",x);
line.setAttribute("x2",x+w+(part*2));
line.setAttribute("y1",_47b);
line.setAttribute("y2",_47b);
line.setAttribute("style","stroke:"+data[i].series.color+";stroke-width:1px;stroke-opacity:0.6;");
g.appendChild(line);
if(_46b){
_46b(g,data[i].src);
}
_46d.appendChild(g);
}
return _46d;
},Scatter:function(data,_480,plot,_482){
var r=7;
var _484=document.createElementNS(dojo.svg.xmlns.svg,"g");
for(var i=0;i<data.length;i++){
var x=plot.axisX.getCoord(data[i].x,_480,plot);
var y=plot.axisY.getCoord(data[i].y,_480,plot);
var _488=document.createElementNS(dojo.svg.xmlns.svg,"path");
_488.setAttribute("fill",data[i].series.color);
_488.setAttribute("stroke-width","0");
_488.setAttribute("d","M "+x+","+(y-r)+" "+"Q "+x+","+y+" "+(x+r)+","+y+" "+"Q "+x+","+y+" "+x+","+(y+r)+" "+"Q "+x+","+y+" "+(x-r)+","+y+" "+"Q "+x+","+y+" "+x+","+(y-r)+" "+"Z");
if(_482){
_482(_488,data[i].src);
}
_484.appendChild(_488);
}
return _484;
},Bubble:function(data,_48a,plot,_48c){
var _48d=document.createElementNS(dojo.svg.xmlns.svg,"g");
var _48e=1;
for(var i=0;i<data.length;i++){
var x=plot.axisX.getCoord(data[i].x,_48a,plot);
var y=plot.axisY.getCoord(data[i].y,_48a,plot);
if(i==0){
var raw=data[i].size;
var dy=plot.axisY.getCoord(data[i].y+raw,_48a,plot)-y;
_48e=dy/raw;
}
if(_48e<1){
_48e=1;
}
var _494=document.createElementNS(dojo.svg.xmlns.svg,"circle");
_494.setAttribute("fill",data[i].series.color);
_494.setAttribute("fill-opacity","0.8");
_494.setAttribute("stroke",data[i].series.color);
_494.setAttribute("stroke-width","1");
_494.setAttribute("cx",x);
_494.setAttribute("cy",y);
_494.setAttribute("r",(data[i].size/2)*_48e);
if(_48c){
_48c(_494,data[i].src);
}
_48d.appendChild(_494);
}
return _48d;
}});
dojo.charting.Plotters["Default"]=dojo.charting.Plotters.Line;
}
dojo.provide("dojo.charting.vml.Plotters");
if(dojo.render.vml.capable){
dojo.mixin(dojo.charting.Plotters,{_group:function(_495){
var _496=document.createElement("div");
_496.style.position="absolute";
_496.style.top="0px";
_496.style.left="0px";
_496.style.width=_495.size.width+"px";
_496.style.height=_495.size.height+"px";
return _496;
},Bar:function(_497,plot,_499,_49a){
var area=_497.getArea();
var _49c=dojo.charting.Plotters._group(_497);
var n=plot.series.length;
var data=[];
for(var i=0;i<n;i++){
var tmp=plot.series[i].data.evaluate(_499);
data.push(tmp);
}
var _4a1=8;
var _4a2=data[0].length;
if(_4a2==0){
return _49c;
}
var _4a3=((area.right-area.left)-(_4a1*(_4a2-1)))/_4a2;
var _4a4=Math.round(_4a3/n);
var _4a5=plot.axisY.getCoord(plot.axisX.origin,_497,plot);
for(var i=0;i<_4a2;i++){
var _4a6=area.left+(_4a3*i)+(_4a1*i);
for(var j=0;j<n;j++){
var _4a8=data[j][i].y;
var yA=_4a5;
var x=_4a6+(_4a4*j);
var y=plot.axisY.getCoord(_4a8,_497,plot);
var h=Math.abs(yA-y);
if(_4a8<plot.axisX.origin){
yA=y;
y=_4a5;
}
var bar=document.createElement("v:rect");
bar.style.position="absolute";
bar.style.top=y+1+"px";
bar.style.left=x+"px";
bar.style.width=_4a4+"px";
bar.style.height=h+"px";
bar.setAttribute("fillColor",data[j][i].series.color);
bar.setAttribute("stroked","false");
bar.style.antialias="false";
var fill=document.createElement("v:fill");
fill.setAttribute("opacity","0.6");
bar.appendChild(fill);
if(_49a){
_49a(bar,data[j][i].src);
}
_49c.appendChild(bar);
}
}
return _49c;
},HorizontalBar:function(_4af,plot,_4b1,_4b2){
var area=_4af.getArea();
var _4b4=dojo.charting.Plotters._group(_4af);
var n=plot.series.length;
var data=[];
for(var i=0;i<n;i++){
var tmp=plot.series[i].data.evaluate(_4b1);
data.push(tmp);
}
var _4b9=6;
var _4ba=data[0].length;
if(_4ba==0){
return _4b4;
}
var h=((area.bottom-area.top)-(_4b9*(_4ba-1)))/_4ba;
var barH=h/n;
var _4bd=plot.axisX.getCoord(0,_4af,plot);
for(var i=0;i<_4ba;i++){
var _4be=area.top+(h*i)+(_4b9*i);
for(var j=0;j<n;j++){
var _4c0=data[j][i].y;
var y=_4be+(barH*j);
var xA=_4bd;
var x=plot.axisX.getCoord(_4c0,_4af,plot);
var w=Math.abs(x-xA);
if(_4c0>0){
x=_4bd;
}
var bar=document.createElement("v:rect");
bar.style.position="absolute";
bar.style.top=y+1+"px";
bar.style.left=xA+"px";
bar.style.width=w+"px";
bar.style.height=barH+"px";
bar.setAttribute("fillColor",data[j][i].series.color);
bar.setAttribute("stroked","false");
bar.style.antialias="false";
var fill=document.createElement("v:fill");
fill.setAttribute("opacity","0.6");
bar.appendChild(fill);
if(_4b2){
_4b2(bar,data[j][i].src);
}
_4b4.appendChild(bar);
}
}
var _4b9=4;
var n=plot.series.length;
var h=((area.bottom-area.top)-(_4b9*(n-1)))/n;
var _4bd=plot.axisX.getCoord(0,_4af,plot);
for(var i=0;i<n;i++){
var _4c7=plot.series[i];
var data=_4c7.data.evaluate(_4b1);
var y=area.top+(h*i)+(_4b9*i);
var _4c0=data[data.length-1].y;
var xA=_4bd;
var x=plot.axisX.getCoord(_4c0,_4af,plot);
var w=Math.abs(xA-x);
if(_4c0>0){
xA=x;
x=_4bd;
}
}
return _4b4;
},Gantt:function(_4c8,plot,_4ca,_4cb){
var area=_4c8.getArea();
var _4cd=dojo.charting.Plotters._group(_4c8);
var n=plot.series.length;
var data=[];
for(var i=0;i<n;i++){
var tmp=plot.series[i].data.evaluate(_4ca);
data.push(tmp);
}
var _4d2=2;
var _4d3=data[0].length;
if(_4d3==0){
return _4cd;
}
var h=((area.bottom-area.top)-(_4d2*(_4d3-1)))/_4d3;
var barH=h/n;
for(var i=0;i<_4d3;i++){
var _4d6=area.top+(h*i)+(_4d2*i);
for(var j=0;j<n;j++){
var high=data[j][i].high;
var low=data[j][i].low;
if(low>high){
var t=high;
high=low;
low=t;
}
var x=plot.axisX.getCoord(low,_4c8,plot);
var w=plot.axisX.getCoord(high,_4c8,plot)-x;
var y=_4d6+(barH*j);
var bar=document.createElement("v:rect");
bar.style.position="absolute";
bar.style.top=y+1+"px";
bar.style.left=x+"px";
bar.style.width=w+"px";
bar.style.height=barH+"px";
bar.setAttribute("fillColor",data[j][i].series.color);
bar.setAttribute("stroked","false");
bar.style.antialias="false";
var fill=document.createElement("v:fill");
fill.setAttribute("opacity","0.6");
bar.appendChild(fill);
if(_4cb){
_4cb(bar,data[j][i].src);
}
_4cd.appendChild(bar);
}
}
return _4cd;
},StackedArea:function(_4e0,plot,_4e2,_4e3){
var area=_4e0.getArea();
var _4e5=dojo.charting.Plotters._group(_4e0);
var n=plot.series.length;
var data=[];
var _4e8=[];
for(var i=0;i<n;i++){
var tmp=plot.series[i].data.evaluate(_4e2);
for(var j=0;j<tmp.length;j++){
if(i==0){
_4e8.push(tmp[j].y);
}else{
_4e8[j]+=tmp[j].y;
}
tmp[j].y=_4e8[j];
}
data.push(tmp);
}
for(var i=n-1;i>=0;i--){
var path=document.createElement("v:shape");
path.setAttribute("strokeweight","1px");
path.setAttribute("strokecolor",data[i][0].series.color);
path.setAttribute("fillcolor",data[i][0].series.color);
path.setAttribute("coordsize",(area.right-area.left)+","+(area.bottom-area.top));
path.style.position="absolute";
path.style.top="0px";
path.style.left="0px";
path.style.width=area.right-area.left+"px";
path.style.height=area.bottom-area.top+"px";
var _4ed=document.createElement("v:stroke");
_4ed.setAttribute("opacity","0.8");
path.appendChild(_4ed);
var fill=document.createElement("v:fill");
fill.setAttribute("opacity","0.4");
path.appendChild(fill);
var cmd=[];
var r=3;
for(var j=0;j<data[i].length;j++){
var _4f1=data[i];
var x=Math.round(plot.axisX.getCoord(_4f1[j].x,_4e0,plot));
var y=Math.round(plot.axisY.getCoord(_4f1[j].y,_4e0,plot));
if(j==0){
cmd.push("m");
cmd.push(x+","+y);
}else{
cmd.push("l");
cmd.push(x+","+y);
}
var c=document.createElement("v:oval");
c.setAttribute("strokeweight","1px");
c.setAttribute("strokecolor",_4f1[j].series.color);
c.setAttribute("fillcolor",_4f1[j].series.color);
var str=document.createElement("v:stroke");
str.setAttribute("opacity","0.8");
c.appendChild(str);
str=document.createElement("v:fill");
str.setAttribute("opacity","0.6");
c.appendChild(str);
var s=c.style;
s.position="absolute";
s.top=(y-r)+"px";
s.left=(x-r)+"px";
s.width=(r*2)+"px";
s.height=(r*2)+"px";
_4e5.appendChild(c);
if(_4e3){
_4e3(c,data[j].src);
}
}
if(i==0){
cmd.push("l");
cmd.push(x+","+Math.round(plot.axisY.getCoord(plot.axisX.origin,_4e0,plot)));
cmd.push("l");
cmd.push(Math.round(plot.axisX.getCoord(data[0][0].x,_4e0,plot))+","+Math.round(plot.axisY.getCoord(plot.axisX.origin,_4e0,plot)));
}else{
var _4f1=data[i-1];
cmd.push("l");
cmd.push(x+","+Math.round(plot.axisY.getCoord(_4f1[_4f1.length-1].y,_4e0,plot)));
for(var j=_4f1.length-2;j>=0;j--){
var x=Math.round(plot.axisX.getCoord(_4f1[j].x,_4e0,plot));
var y=Math.round(plot.axisY.getCoord(_4f1[j].y,_4e0,plot));
cmd.push("l");
cmd.push(x+","+y);
}
}
path.setAttribute("path",cmd.join(" ")+" x e");
_4e5.appendChild(path);
}
return _4e5;
},StackedCurvedArea:function(_4f7,plot,_4f9,_4fa){
var _4fb=3;
var area=_4f7.getArea();
var _4fd=dojo.charting.Plotters._group(_4f7);
var n=plot.series.length;
var data=[];
var _500=[];
for(var i=0;i<n;i++){
var tmp=plot.series[i].data.evaluate(_4f9);
for(var j=0;j<tmp.length;j++){
if(i==0){
_500.push(tmp[j].y);
}else{
_500[j]+=tmp[j].y;
}
tmp[j].y=_500[j];
}
data.push(tmp);
}
for(var i=n-1;i>=0;i--){
var path=document.createElement("v:shape");
path.setAttribute("strokeweight","1px");
path.setAttribute("strokecolor",data[i][0].series.color);
path.setAttribute("fillcolor",data[i][0].series.color);
path.setAttribute("coordsize",(area.right-area.left)+","+(area.bottom-area.top));
path.style.position="absolute";
path.style.top="0px";
path.style.left="0px";
path.style.width=area.right-area.left+"px";
path.style.height=area.bottom-area.top+"px";
var _505=document.createElement("v:stroke");
_505.setAttribute("opacity","0.8");
path.appendChild(_505);
var fill=document.createElement("v:fill");
fill.setAttribute("opacity","0.4");
path.appendChild(fill);
var cmd=[];
var r=3;
for(var j=0;j<data[i].length;j++){
var _509=data[i];
var x=Math.round(plot.axisX.getCoord(_509[j].x,_4f7,plot));
var y=Math.round(plot.axisY.getCoord(_509[j].y,_4f7,plot));
if(j==0){
cmd.push("m");
cmd.push(x+","+y);
}else{
var _50c=Math.round(plot.axisX.getCoord(_509[j-1].x,_4f7,plot));
var _50d=Math.round(plot.axisY.getCoord(_509[j-1].y,_4f7,plot));
var dx=x-_50c;
var dy=y-_50d;
cmd.push("c");
var cx=Math.round((x-(_4fb-1)*(dx/_4fb)));
cmd.push(cx+","+_50d);
cx=Math.round((x-(dx/_4fb)));
cmd.push(cx+","+y);
cmd.push(x+","+y);
}
var c=document.createElement("v:oval");
c.setAttribute("strokeweight","1px");
c.setAttribute("strokecolor",_509[j].series.color);
c.setAttribute("fillcolor",_509[j].series.color);
var str=document.createElement("v:stroke");
str.setAttribute("opacity","0.8");
c.appendChild(str);
str=document.createElement("v:fill");
str.setAttribute("opacity","0.6");
c.appendChild(str);
var s=c.style;
s.position="absolute";
s.top=(y-r)+"px";
s.left=(x-r)+"px";
s.width=(r*2)+"px";
s.height=(r*2)+"px";
_4fd.appendChild(c);
if(_4fa){
_4fa(c,data[j].src);
}
}
if(i==0){
cmd.push("l");
cmd.push(x+","+Math.round(plot.axisY.getCoord(plot.axisX.origin,_4f7,plot)));
cmd.push("l");
cmd.push(Math.round(plot.axisX.getCoord(data[0][0].x,_4f7,plot))+","+Math.round(plot.axisY.getCoord(plot.axisX.origin,_4f7,plot)));
}else{
var _509=data[i-1];
cmd.push("l");
cmd.push(x+","+Math.round(plot.axisY.getCoord(_509[_509.length-1].y,_4f7,plot)));
for(var j=_509.length-2;j>=0;j--){
var x=Math.round(plot.axisX.getCoord(_509[j].x,_4f7,plot));
var y=Math.round(plot.axisY.getCoord(_509[j].y,_4f7,plot));
var _50c=Math.round(plot.axisX.getCoord(_509[j+1].x,_4f7,plot));
var _50d=Math.round(plot.axisY.getCoord(_509[j+1].y,_4f7,plot));
var dx=x-_50c;
var dy=y-_50d;
cmd.push("c");
var cx=Math.round((x-(_4fb-1)*(dx/_4fb)));
cmd.push(cx+","+_50d);
cx=Math.round((x-(dx/_4fb)));
cmd.push(cx+","+y);
cmd.push(x+","+y);
}
}
path.setAttribute("path",cmd.join(" ")+" x e");
_4fd.appendChild(path);
}
return _4fd;
},DataBar:function(data,_515,plot,_517){
var area=_515.getArea();
var _519=dojo.charting.Plotters._group(_515);
var n=data.length;
var w=(area.right-area.left)/(plot.axisX.range.upper-plot.axisX.range.lower);
var _51c=plot.axisY.getCoord(plot.axisX.origin,_515,plot);
for(var i=0;i<n;i++){
var _51e=data[i].y;
var yA=_51c;
var x=plot.axisX.getCoord(data[i].x,_515,plot)-(w/2)+1;
var y=plot.axisY.getCoord(_51e,_515,plot);
var h=Math.abs(yA-y);
if(_51e<plot.axisX.origin){
yA=y;
y=_51c;
}
var bar=document.createElement("v:rect");
bar.style.position="absolute";
bar.style.top=y+1+"px";
bar.style.left=x+"px";
bar.style.width=w+"px";
bar.style.height=h+"px";
bar.setAttribute("fillColor",data[i].series.color);
bar.setAttribute("stroked","false");
bar.style.antialias="false";
var fill=document.createElement("v:fill");
fill.setAttribute("opacity","0.6");
bar.appendChild(fill);
if(_517){
_517(bar,data[i].src);
}
_519.appendChild(bar);
}
return _519;
},Line:function(data,_526,plot,_528){
var area=_526.getArea();
var _52a=dojo.charting.Plotters._group(_526);
if(data.length==0){
return _52a;
}
var path=document.createElement("v:shape");
path.setAttribute("strokeweight","2px");
path.setAttribute("strokecolor",data[0].series.color);
path.setAttribute("fillcolor","none");
path.setAttribute("filled","false");
path.setAttribute("coordsize",(area.right-area.left)+","+(area.bottom-area.top));
path.style.position="absolute";
path.style.top="0px";
path.style.left="0px";
path.style.width=area.right-area.left+"px";
path.style.height=area.bottom-area.top+"px";
var _52c=document.createElement("v:stroke");
_52c.setAttribute("opacity","0.8");
path.appendChild(_52c);
var cmd=[];
var r=3;
for(var i=0;i<data.length;i++){
var x=Math.round(plot.axisX.getCoord(data[i].x,_526,plot));
var y=Math.round(plot.axisY.getCoord(data[i].y,_526,plot));
if(i==0){
cmd.push("m");
cmd.push(x+","+y);
}else{
cmd.push("l");
cmd.push(x+","+y);
}
var c=document.createElement("v:oval");
c.setAttribute("strokeweight","1px");
c.setAttribute("strokecolor",data[i].series.color);
c.setAttribute("fillcolor",data[i].series.color);
var str=document.createElement("v:stroke");
str.setAttribute("opacity","0.8");
c.appendChild(str);
str=document.createElement("v:fill");
str.setAttribute("opacity","0.6");
c.appendChild(str);
var s=c.style;
s.position="absolute";
s.top=(y-r)+"px";
s.left=(x-r)+"px";
s.width=(r*2)+"px";
s.height=(r*2)+"px";
_52a.appendChild(c);
if(_528){
_528(c,data[i].src);
}
}
path.setAttribute("path",cmd.join(" ")+" e");
_52a.appendChild(path);
return _52a;
},CurvedLine:function(data,_536,plot,_538){
var _539=3;
var area=_536.getArea();
var _53b=dojo.charting.Plotters._group(_536);
if(data.length==0){
return _53b;
}
var path=document.createElement("v:shape");
path.setAttribute("strokeweight","2px");
path.setAttribute("strokecolor",data[0].series.color);
path.setAttribute("fillcolor","none");
path.setAttribute("filled","false");
path.setAttribute("coordsize",(area.right-area.left)+","+(area.bottom-area.top));
path.style.position="absolute";
path.style.top="0px";
path.style.left="0px";
path.style.width=area.right-area.left+"px";
path.style.height=area.bottom-area.top+"px";
var _53d=document.createElement("v:stroke");
_53d.setAttribute("opacity","0.8");
path.appendChild(_53d);
var cmd=[];
var r=3;
for(var i=0;i<data.length;i++){
var x=Math.round(plot.axisX.getCoord(data[i].x,_536,plot));
var y=Math.round(plot.axisY.getCoord(data[i].y,_536,plot));
if(i==0){
cmd.push("m");
cmd.push(x+","+y);
}else{
var _543=Math.round(plot.axisX.getCoord(data[i-1].x,_536,plot));
var _544=Math.round(plot.axisY.getCoord(data[i-1].y,_536,plot));
var dx=x-_543;
var dy=y-_544;
cmd.push("c");
var cx=Math.round((x-(_539-1)*(dx/_539)));
cmd.push(cx+","+_544);
cx=Math.round((x-(dx/_539)));
cmd.push(cx+","+y);
cmd.push(x+","+y);
}
var c=document.createElement("v:oval");
c.setAttribute("strokeweight","1px");
c.setAttribute("strokecolor",data[i].series.color);
c.setAttribute("fillcolor",data[i].series.color);
var str=document.createElement("v:stroke");
str.setAttribute("opacity","0.8");
c.appendChild(str);
str=document.createElement("v:fill");
str.setAttribute("opacity","0.6");
c.appendChild(str);
var s=c.style;
s.position="absolute";
s.top=(y-r)+"px";
s.left=(x-r)+"px";
s.width=(r*2)+"px";
s.height=(r*2)+"px";
_53b.appendChild(c);
if(_538){
_538(c,data[i].src);
}
}
path.setAttribute("path",cmd.join(" ")+" e");
_53b.appendChild(path);
return _53b;
},Area:function(data,_54c,plot,_54e){
var area=_54c.getArea();
var _550=dojo.charting.Plotters._group(_54c);
if(data.length==0){
return _550;
}
var path=document.createElement("v:shape");
path.setAttribute("strokeweight","1px");
path.setAttribute("strokecolor",data[0].series.color);
path.setAttribute("fillcolor",data[0].series.color);
path.setAttribute("coordsize",(area.right-area.left)+","+(area.bottom-area.top));
path.style.position="absolute";
path.style.top="0px";
path.style.left="0px";
path.style.width=area.right-area.left+"px";
path.style.height=area.bottom-area.top+"px";
var _552=document.createElement("v:stroke");
_552.setAttribute("opacity","0.8");
path.appendChild(_552);
var fill=document.createElement("v:fill");
fill.setAttribute("opacity","0.4");
path.appendChild(fill);
var cmd=[];
var r=3;
for(var i=0;i<data.length;i++){
var x=Math.round(plot.axisX.getCoord(data[i].x,_54c,plot));
var y=Math.round(plot.axisY.getCoord(data[i].y,_54c,plot));
if(i==0){
cmd.push("m");
cmd.push(x+","+y);
}else{
cmd.push("l");
cmd.push(x+","+y);
}
var c=document.createElement("v:oval");
c.setAttribute("strokeweight","1px");
c.setAttribute("strokecolor",data[i].series.color);
c.setAttribute("fillcolor",data[i].series.color);
var str=document.createElement("v:stroke");
str.setAttribute("opacity","0.8");
c.appendChild(str);
str=document.createElement("v:fill");
str.setAttribute("opacity","0.6");
c.appendChild(str);
var s=c.style;
s.position="absolute";
s.top=(y-r)+"px";
s.left=(x-r)+"px";
s.width=(r*2)+"px";
s.height=(r*2)+"px";
_550.appendChild(c);
if(_54e){
_54e(c,data[i].src);
}
}
cmd.push("l");
cmd.push(x+","+Math.round(plot.axisY.getCoord(plot.axisX.origin,_54c,plot)));
cmd.push("l");
cmd.push(Math.round(plot.axisX.getCoord(data[0].x,_54c,plot))+","+Math.round(plot.axisY.getCoord(plot.axisX.origin,_54c,plot)));
path.setAttribute("path",cmd.join(" ")+" x e");
_550.appendChild(path);
return _550;
},CurvedArea:function(data,_55d,plot,_55f){
var _560=3;
var area=_55d.getArea();
var _562=dojo.charting.Plotters._group(_55d);
if(data.length==0){
return _562;
}
var path=document.createElement("v:shape");
path.setAttribute("strokeweight","1px");
path.setAttribute("strokecolor",data[0].series.color);
path.setAttribute("fillcolor",data[0].series.color);
path.setAttribute("coordsize",(area.right-area.left)+","+(area.bottom-area.top));
path.style.position="absolute";
path.style.top="0px";
path.style.left="0px";
path.style.width=area.right-area.left+"px";
path.style.height=area.bottom-area.top+"px";
var _564=document.createElement("v:stroke");
_564.setAttribute("opacity","0.8");
path.appendChild(_564);
var fill=document.createElement("v:fill");
fill.setAttribute("opacity","0.4");
path.appendChild(fill);
var cmd=[];
var r=3;
for(var i=0;i<data.length;i++){
var x=Math.round(plot.axisX.getCoord(data[i].x,_55d,plot));
var y=Math.round(plot.axisY.getCoord(data[i].y,_55d,plot));
if(i==0){
cmd.push("m");
cmd.push(x+","+y);
}else{
var _56b=Math.round(plot.axisX.getCoord(data[i-1].x,_55d,plot));
var _56c=Math.round(plot.axisY.getCoord(data[i-1].y,_55d,plot));
var dx=x-_56b;
var dy=y-_56c;
cmd.push("c");
var cx=Math.round((x-(_560-1)*(dx/_560)));
cmd.push(cx+","+_56c);
cx=Math.round((x-(dx/_560)));
cmd.push(cx+","+y);
cmd.push(x+","+y);
}
var c=document.createElement("v:oval");
c.setAttribute("strokeweight","1px");
c.setAttribute("strokecolor",data[i].series.color);
c.setAttribute("fillcolor",data[i].series.color);
var str=document.createElement("v:stroke");
str.setAttribute("opacity","0.8");
c.appendChild(str);
str=document.createElement("v:fill");
str.setAttribute("opacity","0.6");
c.appendChild(str);
var s=c.style;
s.position="absolute";
s.top=(y-r)+"px";
s.left=(x-r)+"px";
s.width=(r*2)+"px";
s.height=(r*2)+"px";
_562.appendChild(c);
if(_55f){
_55f(c,data[i].src);
}
}
cmd.push("l");
cmd.push(x+","+Math.round(plot.axisY.getCoord(plot.axisX.origin,_55d,plot)));
cmd.push("l");
cmd.push(Math.round(plot.axisX.getCoord(data[0].x,_55d,plot))+","+Math.round(plot.axisY.getCoord(plot.axisX.origin,_55d,plot)));
path.setAttribute("path",cmd.join(" ")+" x e");
_562.appendChild(path);
return _562;
},HighLow:function(data,_574,plot,_576){
var area=_574.getArea();
var _578=dojo.charting.Plotters._group(_574);
var n=data.length;
var part=((area.right-area.left)/(plot.axisX.range.upper-plot.axisX.range.lower))/4;
var w=part*2;
for(var i=0;i<n;i++){
var high=data[i].high;
var low=data[i].low;
if(low>high){
var t=low;
low=high;
high=t;
}
var x=plot.axisX.getCoord(data[i].x,_574,plot)-(w/2);
var y=plot.axisY.getCoord(high,_574,plot);
var h=plot.axisY.getCoord(low,_574,plot)-y;
var bar=document.createElement("v:rect");
bar.style.position="absolute";
bar.style.top=y+1+"px";
bar.style.left=x+"px";
bar.style.width=w+"px";
bar.style.height=h+"px";
bar.setAttribute("fillColor",data[i].series.color);
bar.setAttribute("stroked","false");
bar.style.antialias="false";
var fill=document.createElement("v:fill");
fill.setAttribute("opacity","0.6");
bar.appendChild(fill);
if(_576){
_576(bar,data[i].src);
}
_578.appendChild(bar);
}
return _578;
},HighLowClose:function(data,_586,plot,_588){
var area=_586.getArea();
var _58a=dojo.charting.Plotters._group(_586);
var n=data.length;
var part=((area.right-area.left)/(plot.axisX.range.upper-plot.axisX.range.lower))/4;
var w=part*2;
for(var i=0;i<n;i++){
var high=data[i].high;
var low=data[i].low;
if(low>high){
var t=low;
low=high;
high=t;
}
var c=data[i].close;
var x=plot.axisX.getCoord(data[i].x,_586,plot)-(w/2);
var y=plot.axisY.getCoord(high,_586,plot);
var h=plot.axisY.getCoord(low,_586,plot)-y;
var _596=plot.axisY.getCoord(c,_586,plot);
var g=document.createElement("div");
var bar=document.createElement("v:rect");
bar.style.position="absolute";
bar.style.top=y+1+"px";
bar.style.left=x+"px";
bar.style.width=w+"px";
bar.style.height=h+"px";
bar.setAttribute("fillColor",data[i].series.color);
bar.setAttribute("stroked","false");
bar.style.antialias="false";
var fill=document.createElement("v:fill");
fill.setAttribute("opacity","0.6");
bar.appendChild(fill);
g.appendChild(bar);
var line=document.createElement("v:line");
line.setAttribute("strokecolor",data[i].series.color);
line.setAttribute("strokeweight","1px");
line.setAttribute("from",x+"px,"+_596+"px");
line.setAttribute("to",(x+w+(part*2)-2)+"px,"+_596+"px");
var s=line.style;
s.position="absolute";
s.top="0px";
s.left="0px";
s.antialias="false";
var str=document.createElement("v:stroke");
str.setAttribute("opacity","0.6");
line.appendChild(str);
g.appendChild(line);
if(_588){
_588(g,data[i].src);
}
_58a.appendChild(g);
}
return _58a;
},HighLowOpenClose:function(data,_59e,plot,_5a0){
var area=_59e.getArea();
var _5a2=dojo.charting.Plotters._group(_59e);
var n=data.length;
var part=((area.right-area.left)/(plot.axisX.range.upper-plot.axisX.range.lower))/4;
var w=part*2;
for(var i=0;i<n;i++){
var high=data[i].high;
var low=data[i].low;
if(low>high){
var t=low;
low=high;
high=t;
}
var o=data[i].open;
var c=data[i].close;
var x=plot.axisX.getCoord(data[i].x,_59e,plot)-(w/2);
var y=plot.axisY.getCoord(high,_59e,plot);
var h=plot.axisY.getCoord(low,_59e,plot)-y;
var open=plot.axisY.getCoord(o,_59e,plot);
var _5b0=plot.axisY.getCoord(c,_59e,plot);
var g=document.createElement("div");
var bar=document.createElement("v:rect");
bar.style.position="absolute";
bar.style.top=y+1+"px";
bar.style.left=x+"px";
bar.style.width=w+"px";
bar.style.height=h+"px";
bar.setAttribute("fillColor",data[i].series.color);
bar.setAttribute("stroked","false");
bar.style.antialias="false";
var fill=document.createElement("v:fill");
fill.setAttribute("opacity","0.6");
bar.appendChild(fill);
g.appendChild(bar);
var line=document.createElement("v:line");
line.setAttribute("strokecolor",data[i].series.color);
line.setAttribute("strokeweight","1px");
line.setAttribute("from",(x-(part*2))+"px,"+open+"px");
line.setAttribute("to",(x+w-2)+"px,"+open+"px");
var s=line.style;
s.position="absolute";
s.top="0px";
s.left="0px";
s.antialias="false";
var str=document.createElement("v:stroke");
str.setAttribute("opacity","0.6");
line.appendChild(str);
g.appendChild(line);
var line=document.createElement("v:line");
line.setAttribute("strokecolor",data[i].series.color);
line.setAttribute("strokeweight","1px");
line.setAttribute("from",x+"px,"+_5b0+"px");
line.setAttribute("to",(x+w+(part*2)-2)+"px,"+_5b0+"px");
var s=line.style;
s.position="absolute";
s.top="0px";
s.left="0px";
s.antialias="false";
var str=document.createElement("v:stroke");
str.setAttribute("opacity","0.6");
line.appendChild(str);
g.appendChild(line);
if(_5a0){
_5a0(g,data[i].src);
}
_5a2.appendChild(g);
}
return _5a2;
},Scatter:function(data,_5b8,plot,_5ba){
var r=6;
var mod=r/2;
var area=_5b8.getArea();
var _5be=dojo.charting.Plotters._group(_5b8);
for(var i=0;i<data.length;i++){
var x=Math.round(plot.axisX.getCoord(data[i].x,_5b8,plot));
var y=Math.round(plot.axisY.getCoord(data[i].y,_5b8,plot));
var _5c2=document.createElement("v:rect");
_5c2.setAttribute("strokecolor",data[i].series.color);
_5c2.setAttribute("fillcolor",data[i].series.color);
var fill=document.createElement("v:fill");
fill.setAttribute("opacity","0.6");
_5c2.appendChild(fill);
var s=_5c2.style;
s.position="absolute";
s.rotation="45";
s.top=(y-mod)+"px";
s.left=(x-mod)+"px";
s.width=r+"px";
s.height=r+"px";
_5be.appendChild(_5c2);
if(_5ba){
_5ba(_5c2,data[i].src);
}
}
return _5be;
},Bubble:function(data,_5c6,plot,_5c8){
var _5c9=1;
var area=_5c6.getArea();
var _5cb=dojo.charting.Plotters._group(_5c6);
for(var i=0;i<data.length;i++){
var x=Math.round(plot.axisX.getCoord(data[i].x,_5c6,plot));
var y=Math.round(plot.axisY.getCoord(data[i].y,_5c6,plot));
if(i==0){
var raw=data[i].size;
var dy=plot.axisY.getCoord(data[i].y+raw,_5c6,plot)-y;
_5c9=dy/raw;
}
if(_5c9<1){
_5c9=1;
}
var r=(data[i].size/2)*_5c9;
var _5d2=document.createElement("v:oval");
_5d2.setAttribute("strokecolor",data[i].series.color);
_5d2.setAttribute("fillcolor",data[i].series.color);
var fill=document.createElement("v:fill");
fill.setAttribute("opacity","0.6");
_5d2.appendChild(fill);
var s=_5d2.style;
s.position="absolute";
s.rotation="45";
s.top=(y-r)+"px";
s.left=(x-r)+"px";
s.width=(r*2)+"px";
s.height=(r*2)+"px";
_5cb.appendChild(_5d2);
if(_5c8){
_5c8(_5d2,data[i].src);
}
}
return _5cb;
}});
dojo.charting.Plotters["Default"]=dojo.charting.Plotters.Line;
}
dojo.provide("dojo.charting.Series");
dojo.charting.Series=function(_5d5){
var args=_5d5||{length:1};
this.dataSource=args.dataSource||null;
this.bindings={};
this.color=args.color;
this.label=args.label;
if(args.bindings){
for(var p in args.bindings){
this.addBinding(p,args.bindings[p]);
}
}
};
dojo.extend(dojo.charting.Series,{bind:function(src,_5d9){
this.dataSource=src;
this.bindings=_5d9;
},addBinding:function(name,_5db){
this.bindings[name]=_5db;
},evaluate:function(_5dc){
var ret=[];
var a=this.dataSource.getData();
var l=a.length;
var _5e0=0;
var end=l;
if(_5dc){
if(_5dc.between){
for(var i=0;i<l;i++){
var fld=this.dataSource.getField(a[i],_5dc.between.field);
if(fld>=_5dc.between.low&&fld<=_5dc.between.high){
var o={src:a[i],series:this};
for(var p in this.bindings){
o[p]=this.dataSource.getField(a[i],this.bindings[p]);
}
ret.push(o);
}
}
}else{
if(_5dc.from||_5dc.length){
if(_5dc.from){
_5e0=Math.max(_5dc.from,0);
if(_5dc.to){
end=Math.min(_5dc.to,end);
}
}else{
if(_5dc.length<0){
_5e0=Math.max((end+length),0);
}else{
end=Math.min((_5e0+length),end);
}
}
for(var i=_5e0;i<end;i++){
var o={src:a[i],series:this};
for(var p in this.bindings){
o[p]=this.dataSource.getField(a[i],this.bindings[p]);
}
ret.push(o);
}
}
}
}else{
for(var i=_5e0;i<end;i++){
var o={src:a[i],series:this};
for(var p in this.bindings){
o[p]=this.dataSource.getField(a[i],this.bindings[p]);
}
ret.push(o);
}
}
if(ret.length>0&&typeof (ret[0].x)!="undefined"){
ret.sort(function(a,b){
if(a.x>b.x){
return 1;
}
if(a.x<b.x){
return -1;
}
return 0;
});
}
return ret;
},trends:{createRange:function(_5e8,len){
var idx=_5e8.length-1;
var _5eb=(len||_5e8.length);
return {"index":idx,"length":_5eb,"start":Math.max(idx-_5eb,0)};
},mean:function(_5ec,len){
var _5ee=this.createRange(_5ec,len);
if(_5ee.index<0){
return 0;
}
var _5ef=0;
var _5f0=0;
for(var i=_5ee.index;i>=_5ee.start;i--){
_5ef+=_5ec[i].y;
_5f0++;
}
_5ef/=Math.max(_5f0,1);
return _5ef;
},variance:function(_5f2,len){
var _5f4=this.createRange(_5f2,len);
if(_5f4.index<0){
return 0;
}
var _5f5=0;
var _5f6=0;
var _5f7=0;
for(var i=_5f4.index;i>=_5f4.start;i--){
_5f5+=_5f2[i].y;
_5f6+=Math.pow(_5f2[i].y,2);
_5f7++;
}
return (_5f6/_5f7)-Math.pow(_5f5/_5f7,2);
},standardDeviation:function(_5f9,len){
return Math.sqrt(this.getVariance(_5f9,len));
},max:function(_5fb,len){
var _5fd=this.createRange(_5fb,len);
if(_5fd.index<0){
return 0;
}
var max=Number.MIN_VALUE;
for(var i=_5fd.index;i>=_5fd.start;i--){
max=Math.max(_5fb[i].y,max);
}
return max;
},min:function(_600,len){
var _602=this.createRange(_600,len);
if(_602.index<0){
return 0;
}
var min=Number.MAX_VALUE;
for(var i=_602.index;i>=_602.start;i--){
min=Math.min(_600[i].y,min);
}
return min;
},median:function(_605,len){
var _607=this.createRange(_605,len);
if(_607.index<0){
return 0;
}
var a=[];
for(var i=_607.index;i>=_607.start;i--){
var b=false;
for(var j=0;j<a.length;j++){
if(_605[i].y==a[j]){
b=true;
break;
}
}
if(!b){
a.push(_605[i].y);
}
}
a.sort();
if(a.length>0){
return a[Math.ceil(a.length/2)];
}
return 0;
},mode:function(_60c,len){
var _60e=this.createRange(_60c,len);
if(_60e.index<0){
return 0;
}
var o={};
var ret=0;
var _611=Number.MIN_VALUE;
for(var i=_60e.index;i>=_60e.start;i--){
if(!o[_60c[i].y]){
o[_60c[i].y]=1;
}else{
o[_60c[i].y]++;
}
}
for(var p in o){
if(_611<o[p]){
_611=o[p];
ret=p;
}
}
return ret;
}}});
dojo.provide("dojo.charting.Plot");
dojo.charting.RenderPlotSeries={Singly:"single",Grouped:"grouped"};
dojo.charting.Plot=function(_614,_615,_616){
var id="dojo-charting-plot-"+dojo.charting.Plot.count++;
this.getId=function(){
return id;
};
this.setId=function(key){
id=key;
};
this.axisX=null;
this.axisY=null;
this.series=[];
this.dataNode=null;
this.renderType=dojo.charting.RenderPlotSeries.Singly;
if(_614){
this.setAxis(_614,"x");
}
if(_615){
this.setAxis(_615,"y");
}
if(_616){
for(var i=0;i<_616.length;i++){
this.addSeries(_616[i]);
}
}
};
dojo.charting.Plot.count=0;
dojo.extend(dojo.charting.Plot,{addSeries:function(_61a,_61b){
if(_61a.plotter){
this.series.push(_61a);
}else{
this.series.push({data:_61a,plotter:_61b||dojo.charting.Plotters["Default"]});
}
},setAxis:function(axis,_61d){
if(_61d.toLowerCase()=="x"){
this.axisX=axis;
}else{
if(_61d.toLowerCase()=="y"){
this.axisY=axis;
}
}
},getRanges:function(){
var xmin,xmax,ymin,ymax;
xmin=ymin=Number.MAX_VALUE;
xmax=ymax=Number.MIN_VALUE;
for(var i=0;i<this.series.length;i++){
var _623=this.series[i].data.evaluate();
for(var j=0;j<_623.length;j++){
var comp=_623[j];
xmin=Math.min(comp.x,xmin);
ymin=Math.min(comp.y,ymin);
xmax=Math.max(comp.x,xmax);
ymax=Math.max(comp.y,ymax);
}
}
return {x:{upper:xmax,lower:xmin},y:{upper:ymax,lower:ymin},toString:function(){
return "[ x:"+xmax+" - "+xmin+", y:"+ymax+" - "+ymin+"]";
}};
},destroy:function(){
var node=this.dataNode;
while(node&&node.childNodes&&node.childNodes.length>0){
node.removeChild(node.childNodes[0]);
}
this.dataNode=null;
}});
dojo.provide("dojo.charting.PlotArea");
dojo.charting.PlotArea=function(){
var id="dojo-charting-plotarea-"+dojo.charting.PlotArea.count++;
this.getId=function(){
return id;
};
this.setId=function(key){
id=key;
};
this.areaType="standard";
this.plots=[];
this.size={width:600,height:400};
this.padding={top:10,right:10,bottom:20,left:20};
this.nodes={main:null,area:null,background:null,axes:null,plots:null};
this._color={h:140,s:120,l:120,step:27};
};
dojo.charting.PlotArea.count=0;
dojo.extend(dojo.charting.PlotArea,{nextColor:function(){
var rgb=dojo.gfx.color.hsl2rgb(this._color.h,this._color.s,this._color.l);
this._color.h=(this._color.h+this._color.step)%360;
while(this._color.h<140){
this._color.h+=this._color.step;
}
return dojo.gfx.color.rgb2hex(rgb[0],rgb[1],rgb[2]);
},getArea:function(){
return {left:this.padding.left,right:this.size.width-this.padding.right,top:this.padding.top,bottom:this.size.height-this.padding.bottom,toString:function(){
var a=[this.top,this.right,this.bottom,this.left];
return "["+a.join()+"]";
}};
},getAxes:function(){
var axes={};
for(var i=0;i<this.plots.length;i++){
var plot=this.plots[i];
axes[plot.axisX.getId()]={axis:plot.axisX,drawAgainst:plot.axisY,plot:plot,plane:"x"};
axes[plot.axisY.getId()]={axis:plot.axisY,drawAgainst:plot.axisX,plot:plot,plane:"y"};
}
return axes;
},getLegendInfo:function(){
var a=[];
for(var i=0;i<this.plots.length;i++){
for(var j=0;j<this.plots[i].series.length;j++){
var data=this.plots[i].series[j].data;
a.push({label:data.label,color:data.color});
}
}
return a;
},setAxesRanges:function(){
var _632={};
var axes={};
for(var i=0;i<this.plots.length;i++){
var plot=this.plots[i];
var _632=plot.getRanges();
var x=_632.x;
var y=_632.y;
var ax,ay;
if(!axes[plot.axisX.getId()]){
axes[plot.axisX.getId()]=plot.axisX;
_632[plot.axisX.getId()]={upper:x.upper,lower:x.lower};
}
ax=_632[plot.axisX.getId()];
ax.upper=Math.max(ax.upper,x.upper);
ax.lower=Math.min(ax.lower,x.lower);
if(!axes[plot.axisY.getId()]){
axes[plot.axisY.getId()]=plot.axisY;
_632[plot.axisY.getId()]={upper:y.upper,lower:y.lower};
}
ay=_632[plot.axisY.getId()];
ay.upper=Math.max(ay.upper,y.upper);
ay.lower=Math.min(ay.lower,y.lower);
}
for(var p in axes){
axes[p].range=_632[p];
}
},render:function(_63b,_63c){
if(!this.nodes.main||!this.nodes.area||!this.nodes.background||!this.nodes.plots||!this.nodes.axes){
this.initialize();
}
this.resize();
for(var i=0;i<this.plots.length;i++){
var plot=this.plots[i];
if(plot.dataNode){
this.nodes.plots.removeChild(plot.dataNode);
}
var _63f=this.initializePlot(plot);
switch(plot.renderType){
case dojo.charting.RenderPlotSeries.Grouped:
if(plot.series[0]){
_63f.appendChild(plot.series[0].plotter(this,plot,_63b,_63c));
}
break;
case dojo.charting.RenderPlotSeries.Singly:
default:
for(var j=0;j<plot.series.length;j++){
var _641=plot.series[j];
var data=_641.data.evaluate(_63b);
_63f.appendChild(_641.plotter(data,this,plot,_63c));
}
}
this.nodes.plots.appendChild(_63f);
}
},destroy:function(){
for(var i=0;i<this.plots.length;i++){
this.plots[i].destroy();
}
for(var p in this.nodes){
var node=this.nodes[p];
if(!node){
continue;
}
if(!node.childNodes){
continue;
}
while(node.childNodes.length>0){
node.removeChild(node.childNodes[0]);
}
this.nodes[p]=null;
}
}});
dojo.requireIf(dojo.render.svg.capable,"dojo.charting.svg.PlotArea");
dojo.requireIf(dojo.render.vml.capable,"dojo.charting.vml.PlotArea");
dojo.provide("dojo.charting.svg.PlotArea");
if(dojo.render.svg.capable){
dojo.extend(dojo.charting.PlotArea,{resize:function(){
var area=this.getArea();
this.nodes.area.setAttribute("width",this.size.width);
this.nodes.area.setAttribute("height",this.size.height);
var rect=this.nodes.area.getElementsByTagName("rect")[0];
rect.setAttribute("x",area.left);
rect.setAttribute("y",area.top);
rect.setAttribute("width",area.right-area.left);
rect.setAttribute("height",area.bottom-area.top);
this.nodes.background.setAttribute("width",this.size.width);
this.nodes.background.setAttribute("height",this.size.height);
if(this.nodes.plots){
this.nodes.area.removeChild(this.nodes.plots);
this.nodes.plots=null;
}
this.nodes.plots=document.createElementNS(dojo.svg.xmlns.svg,"g");
this.nodes.plots.setAttribute("id",this.getId()+"-plots");
this.nodes.plots.setAttribute("style","clip-path:url(#"+this.getId()+"-clip);");
this.nodes.area.appendChild(this.nodes.plots);
for(var i=0;i<this.plots.length;i++){
this.nodes.plots.appendChild(this.initializePlot(this.plots[i]));
}
if(this.nodes.axes){
this.nodes.area.removeChild(this.nodes.axes);
this.nodes.axes=null;
}
this.nodes.axes=document.createElementNS(dojo.svg.xmlns.svg,"g");
this.nodes.axes.setAttribute("id",this.getId()+"-axes");
this.nodes.area.appendChild(this.nodes.axes);
var axes=this.getAxes();
for(var p in axes){
var obj=axes[p];
this.nodes.axes.appendChild(obj.axis.initialize(this,obj.plot,obj.drawAgainst,obj.plane));
}
},initializePlot:function(plot){
plot.destroy();
plot.dataNode=document.createElementNS(dojo.svg.xmlns.svg,"g");
plot.dataNode.setAttribute("id",plot.getId());
return plot.dataNode;
},initialize:function(){
this.destroy();
this.nodes.main=document.createElement("div");
this.nodes.area=document.createElementNS(dojo.svg.xmlns.svg,"svg");
this.nodes.area.setAttribute("id",this.getId());
this.nodes.main.appendChild(this.nodes.area);
var defs=document.createElementNS(dojo.svg.xmlns.svg,"defs");
var clip=document.createElementNS(dojo.svg.xmlns.svg,"clipPath");
clip.setAttribute("id",this.getId()+"-clip");
var rect=document.createElementNS(dojo.svg.xmlns.svg,"rect");
clip.appendChild(rect);
defs.appendChild(clip);
this.nodes.area.appendChild(defs);
this.nodes.background=document.createElementNS(dojo.svg.xmlns.svg,"rect");
this.nodes.background.setAttribute("id",this.getId()+"-background");
this.nodes.background.setAttribute("fill","#fff");
this.nodes.area.appendChild(this.nodes.background);
this.resize();
return this.nodes.main;
}});
}
dojo.provide("dojo.charting.vml.PlotArea");
if(dojo.render.vml.capable){
dojo.extend(dojo.charting.PlotArea,{resize:function(){
var a=this.getArea();
this.nodes.area.style.width=this.size.width+"px";
this.nodes.area.style.height=this.size.height+"px";
this.nodes.background.style.width=this.size.width+"px";
this.nodes.background.style.height=this.size.height+"px";
this.nodes.plots.width=this.size.width+"px";
this.nodes.plots.height=this.size.height+"px";
this.nodes.plots.style.clip="rect("+a.top+" "+a.right+" "+a.bottom+" "+a.left+")";
if(this.nodes.axes){
this.nodes.area.removeChild(this.nodes.axes);
}
var axes=this.nodes.axes=document.createElement("div");
axes.id=this.getId()+"-axes";
this.nodes.area.appendChild(axes);
var ax=this.getAxes();
for(var p in ax){
var obj=ax[p];
axes.appendChild(obj.axis.initialize(this,obj.plot,obj.drawAgainst,obj.plane));
}
},initializePlot:function(plot){
plot.destroy();
plot.dataNode=document.createElement("div");
plot.dataNode.id=plot.getId();
return plot.dataNode;
},initialize:function(){
this.destroy();
var main=this.nodes.main=document.createElement("div");
var area=this.nodes.area=document.createElement("div");
area.id=this.getId();
area.style.position="absolute";
main.appendChild(area);
var bg=this.nodes.background=document.createElement("div");
bg.id=this.getId()+"-background";
bg.style.position="absolute";
bg.style.top="0px";
bg.style.left="0px";
bg.style.backgroundColor="#fff";
area.appendChild(bg);
var a=this.getArea();
var _65a=this.nodes.plots=document.createElement("div");
_65a.id=this.getId()+"-plots";
_65a.style.position="absolute";
_65a.style.top="0px";
_65a.style.left="0px";
area.appendChild(_65a);
for(var i=0;i<this.plots.length;i++){
_65a.appendChild(this.initializePlot(this.plots[i]));
}
this.resize();
return main;
}});
}
dojo.provide("dojo.charting.Chart");
dojo.charting.Chart=function(node,_65d,_65e){
this.node=node||null;
this.title=_65d||"Chart";
this.description=_65e||"";
this.plotAreas=[];
};
dojo.extend(dojo.charting.Chart,{addPlotArea:function(obj,_660){
if(obj.x!=null&&obj.left==null){
obj.left=obj.x;
}
if(obj.y!=null&&obj.top==null){
obj.top=obj.y;
}
this.plotAreas.push(obj);
if(_660){
this.render();
}
},onInitialize:function(_661){
},onRender:function(_662){
},onDestroy:function(_663){
},initialize:function(){
if(!this.node){
dojo.raise("dojo.charting.Chart.initialize: there must be a root node defined for the Chart.");
}
this.destroy();
this.render();
this.onInitialize(this);
},render:function(){
if(this.node.style.position!="absolute"){
this.node.style.position="relative";
}
for(var i=0;i<this.plotAreas.length;i++){
var area=this.plotAreas[i].plotArea;
var node=area.initialize();
node.style.position="absolute";
node.style.top=this.plotAreas[i].top+"px";
node.style.left=this.plotAreas[i].left+"px";
this.node.appendChild(node);
area.render();
}
},destroy:function(){
for(var i=0;i<this.plotAreas.length;i++){
this.plotAreas[i].plotArea.destroy();
}
while(this.node&&this.node.childNodes&&this.node.childNodes.length>0){
this.node.removeChild(this.node.childNodes[0]);
}
}});

